Go to the first, previous, next, last section, table of contents.

# 6 Settings and resources

In the VICE emulators, all the settings are stored in entities known as called resources. Each resource has a name and a value which may be either an integer or a string. Integer values are often used as boolean values with the usual convention of using zero for "false" and any other value for "true".

Resource values can be changed via the the options menu, via command-line options, using monitor commands, or via the resource file.

The resource file is a human-readable file containing resource values: On windows systems it is called ``vice.ini'` and is usually stored in the users roaming profile directory (something like ``C:\Users\'`<username>``\AppData\Roaming\vice'`). Additionally the emulators will look in the program directory at startup, and use ``vice.ini'` if it exists there. On unix systems the resource file is called ``vicerc'` and is stored in the users config directory according to the XDG specification (usually ``/home/'`<username>``/.config/vice/'`). Additionally the emulators will look if ``.vicerc'` exists in the users home directory, and use that if so.

It is possible to dump the current values of the resources into that file or load the values stored into that file as the current values, at any time. This is achieved with the "Save settings" and "Load settings" right menu items. A third menu item, "Restore Default Settings", can be used to reset all the values to the factory defaults.

A special resource, `SaveResourcesOnExit`, if set to a non zero value, causes the emulator to save the current (changed) settings before exiting, and can be toggled with the "Save settings on exit" item from the options menu.

## 6.1 Format of resource files

A resource file is made up of several sections; sections have the purpose of separating the resources of a certain emulator from the ones of the other emulators. A section starts with the name of an emulator in brackets (e.g., ``[C64]'`) and ends when another section starts or when the file ends.

Every line in a section has the following format:

    RESOURCE=VALUE

where `RESOURCE` is the name of a resource and `VALUE` is its assigned value. Resource names are case-sensitive and resource values are either strings or integers. Strings must start and end with a double quote character (`"`), while integers must be given in decimal notation.

Here is an example of a stripped-down ``.vice/vicerc'` file:

    [VIC20]
    SaveResourcesOnExit=0
    FileSystemDevice8=1
    FSDevice8ConvertP00=1
    FSDevice8Dir="/home/ettore/cbm/stuff/vic20p00"
    FSDevice8SaveP00=1
    FSDevice8HideCBMFiles=1
    [C64]
    SaveResourcesOnExit=1
    FileSystemDevice8=1
    FSDevice8ConvertP00=1
    FSDevice8Dir="/home/ettore/cbm/stuff/c64p00"
    FSDevice8SaveP00=1
    FSDevice8HideCBMFiles=1

Notice that, when resource values are saved with "Save settings", the emulator only modifies its own section, leaving the others unchanged.

## 6.2 Using command-line options to change resources

Resources can also be changed via command-line options.

Command-line options always override the defaults from `.vice/vicerc`, and their assignments last for the whole session. So, if you specify a certain command-line option that changes a certain resource from its default value and then use "Save Settings", the value specified with the command-line option will be saved back to the resource file.

Command-line options can begin with with a minus sign (``-'`) or with a plus sign (``+'`). Options beginning with a minus sign may require an additional parameter, while the ones beginning with the plus sign never require one.

Moreover, options beginning with a plus sign always have a counterpart with the same name, but with a minus sign; in that case, the option beginning with a minus sign is used to enable a certain feature, while the one beginning with a plus sign is used to disable the same feature (this is an X11 convention). For example, `-warp` enables initial warp mode, while `+warp` disables it.

## 6.3 Autostart settings

### 6.3.1 Autostart resources

All these resources are available for all emulators except vsid.

`AutostartPrgDiskImage`
  String specifying the filename of the disk image used when autostarting a prg file and "copy to D64" is enabled (all emulators except vsid).
`AutostartBasicLoad`
  Boolean, if true load to basic start using ,8 when autostarting from disk, else use ,8,1 to load absolute. (all emulators except vsid).
`AutostartTapeBasicLoad`
  Boolean, if true load to basic start using ,1 when autostarting from tape, else use ,1,1 to load absolute. (all emulators except vsid).
`AutostartRunWithColon`
  Boolean, if true put a colon after the load command when autostarting (all emulators except vsid).
`AutostartHandleTrueDriveEmulation`
  Boolean, if true handle (enable/disable) True Drive Emulation on autostart (all emulators except vsid). This is disabled by default to ensure maximum compatibility.
`AutostartWarp`
  Boolean, if true temporarily enable warp mode when autostarting (all emulators except vsid).
`AutostartPrgMode`
  Integer specifying the autostart mode for prg files (all emulators except vsid). (0: virtual filesystem, 1: inject to RAM, 2: copy to D64)
`AutostartDelayRandom`
  Boolean, enables a short (0-10 frames) random delay on autostart. This is added to the `AutostartDelay` (all emulators except vsid).
`AutostartDelay`
  Integer specifying the delay in seconds required to wait for the kernal reset routine before autostart. (0: use builtin value for standard kernal) When tweaking this value start with 'large' values and then lower it, a value that is too small results in autostart not happening. (all emulators except vsid). (0..1000)
`AutostartOnDoubleClick`
  Use autostart when double clicking on a file in the file list. (only in the GTK3 GUI) (all emulators except vsid)
`AutostartDropMode`
  Integer specifying autostart behaviour when dropping an image on the emulator window using drag-n-drop (all emulators except vsid). (0: attach only, 1: attach and load, 2: attach, load and run)

### 6.3.2 Autostart command-line options

All these command-line options are available for all emulators except vsid.

`-autostartprgdiskimage <Name>`
  Set disk image for autostart of PRG files (`AutostartPrgDiskImage`) (all emulators except vsid).
`-basicload`
  On autostart from disk, load to BASIC start (without ',1') (`AutostartBasicLoad=1`) (all emulators except vsid).
`+basicload`
  On autostart from disk, load with ',1' (`AutostartBasicLoad=0`) (all emulators except vsid).
`-tapebasicload`
  On autostart from tape, load to BASIC start (without ',1') (`AutostartTapeBasicLoad=1`) (all emulators except vsid).
`+tapebasicload`
  On autostart from tape, load with ',1' (`AutostartTapeBasicLoad=0`) (all emulators except vsid).
`-autostarttapoffset <Offset>`
  Set initial offset in the .tap file (useful for emulator frontends)
`-autostartwithcolon`
  On autostart, use the 'RUN' command with a colon, i.e., 'RUN:' (`AutostartRunWithColon=1`). (all emulators except vsid)
`+autostartwithcolon`
  On autostart, do not use the 'RUN' command with a colon; i.e., 'RUN' (`AutostartRunWithColon=0`) (all emulators except vsid).
`-autostart-handle-tde`
`+autostart-handle-tde`
  Handle/Do not handle True Drive Emulation on autostart (`AutostartHandleTrueDriveEmulation=1`, `AutostartHandleTrueDriveEmulation=0`) (all emulators except vsid).
`-autostart-warp`
`+autostart-warp`
  Enable/disable warp mode during autostart (`AutostartWarp=1`, `AutostartWarp=0`) (all emulators except vsid).
`-autostartprgmode <Mode>`
  Set autostart mode for PRG files (`AutostartPrgMode`) (all emulators except vsid). (0: virtual filesystem, 1: inject to RAM, 2: copy to D64)
`-autostart-delay-random`
`+autostart-delay-random`
  Enable/disable random delay on autostart (`AutostartDelayRandom`) (all emulators except vsid).
`-autostart-delay <seconds>`
  Set initial autostart delay in seconds for the kernal reset routine before autostart. (0: use builtin value for standard kernal). When tweaking this value start with 'large' values and then lower it, a value that is too small results in autostart not happening. (`AutostartDelay`) (all emulators except vsid). (0..1000)
`-autostart-on-doubleclick`
`+autostart-on-doubleclick`
  Enable/disable using autostart when double clicking on a file in the file list. (`AutostartOnDoubleClick`) (only in the GTK3 GUI) (all emulators except vsid)
`-autostart-drop-mode <mode>`
  Set autostart behaviour on dropping an image onto the emulator window (`AutostartDropMode`) (all emulators exceot vsid). (0/"attach": attach only, 1/"load": attach and load, 2/"run": attach, load and run)

## 6.4 Performance settings

It is possible to control the emulation speed by using the "Maximum speed" item in the speed setting. The default setting is `100`, which causes the emulation to never run faster than the real machine. A higher value allows the emulator to run faster, a lower one may force it to run slower. A specific FPS may also be targeted.

Moreover, a special warp speed mode is provided and can be toggled with the "Enable Warp Mode" menu item. If this mode is enabled, it will cause the emulator to disable any speed limit, turn sound output off and use a 1/10 refresh rate, so that it will run at the maximum possible speed.

### 6.4.1 Performance resources

`Speed`
  Integer specifying the maximum relative speed, as a percentage. `0` stands for "no limit".
`InitialWarpMode`
  Booolean specifying whether "warp mode" is initially enabled.

### 6.4.2 Performance command-line options

`-speed <value>`
  A positive <value> specifies the maximum speed as a percentage. A negative <value> results in a target FPS of 0 - <value> (`Speed`).
`-warp`
`+warp`
  Enable/Disable the initial warp mode.

## 6.5 Video settings

The following right-button menu items control the video output. On emulators that include two video chips (like `x128`) all options exist twice, once for each chip.

- "Video Cache" enables a video cache that can speed up the emulation when little graphics activity is going on; it is especially useful when you run the emulator on a networked X terminal as it can reduce the network bandwidth required. However, this setting can actually make the emulator slower when there is little graphics activity and the amount of work needed to maintain the cache is greater than the amount of work that would be wasted by not using it (if any).
- "Double Size" toggles double-size mode, which makes the emulation window twice as big. It also selects a more accurate CRT emulation renderer with scanlines.
- "Double Scan" toggles double-scan mode, which causes the emulator to draw only odd lines when running in double-size mode (this saves some CPU time and also makes the emulation window look more like an old monitor).

## 6.6 Keyboard settings

It is possible to specify whether the "positional" or "symbolic" keyboard mapping should be used with the "Keyboard mapping type" submenu (see section 1.2 The keyboard emulation for an explanation of positional and symbolic mappings).

The keyboard settings also allows you to:

- Load custom-made positional and symbolic keymap files ("Set symbolic keymap file" and "Set positional keymap file").
- Dump the current keymap to a user-defined keymap file ("Dump to keymap file").

### 6.6.1 Keyboard resources

`KeymapIndex`
  Integer identifying which keymap is being used. (0: symbolic, 1: positional, 2: symbolic (user), 3: positional (user)).
`KeymapSymFile`
  String specifying the name of the keymap file for the symbolic mapping (see section 1.2 The keyboard emulation (this will be set indirectly by changing `KeymapIndex`, `KeyboardMapping` or `KeyboardType`).
`KeymapPosFile`
  String specifying the name of the keymap file for the positional mapping (see section 1.2 The keyboard emulation (this will be set indirectly by changing `KeymapIndex`, `KeyboardMapping` or `KeyboardType`).
`KeymapUserSymFile`
  String specifying the name of the user keymap file for symbolic mapping (see section 1.2 The keyboard emulation
`KeymapUserPosFile`
  String specifying the name of the user keymap file for positional mapping (see section 1.2 The keyboard emulation
`KeyboardMapping`
  Integer specifying the keyboard layout of the host. (0: American 1: British 2: Danish 3: Dutch 4: Finnish 5: French 6: German 7: Italian 8: Norwegian 9: Spanish 10: Swedish 11: Swiss 12: Turkish).
`KeyboardType`
  Integer specifying the emulated type of keyboard. (machine specific, currently always 0 except for xpet: 0: Business (us) 1: Business (uk) 2: Business (de) 3: Business (jp) 4: Graphics (us)).

### 6.6.2 Keyboard command-line options

`-keymap <number>`
  Specifies which keymap is being used (`KeymapIndex` 0: symbolic, 1: positional, 2: symbolic (user), 3: positional (user)).
`-symkeymap <Name>`
  Specify filename of the symbolic user keymap file (`KeymapUserSymFile`).
`-poskeymap <Name>`
  Specify filename of the positional user keymap file (`KeymapUserPosFile`).
`-keyboardmapping <number>`
  Specifies the keyboard layout of the host (`KeyboardMapping` (0: American 1: British 2: Danish 3: Dutch 4: Finnish 5: French 6: German 7: Italian 8: Norwegian 9: Spanish 10: Swedish 11: Swiss 12: Turkish).
`-keyboardtype <number>`
  Specifies the emulated type of keyboard (`KeyboardType` machine specific, currently always 0 except for xpet: 0: Business (us) 1: Business (uk) 2: Business (de) 3: Business (jp) 4: Graphics (us)).

## 6.7 Control port settings

The control port settings submenu allows you to select which control port device is connected to a control port.

### 6.7.1 Control port resources

`JoyPort1Device`
  Set the device attached to: control port 1 (x64, x64sc, x64dtv, xscpu64, x128, xcbm5x0, xplus4) control port (xvic). (section 6.7.3 Control port and devices).
`JoyPort2Device`
  Set the device attached to: control port 2 (x64, x64sc, x64dtv, xscpu64, x128, xcbm5x0, xplus4) (section 6.7.3 Control port and devices).
`JoyPort3Device`
  Set the device attached to: joystick adapter port 1 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xpet, xvic, xplus4) (section 6.7.3 Control port and devices).
`JoyPort4Device`
  Set the device attached to: joystick adapter port 2 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xpet, xvic, xplus4) (section 6.7.3 Control port and devices).
`JoyPort5Device`
  Set the device attached to: joystick adapter port 3 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xpet, xvic, xplus4) (section 6.7.3 Control port and devices).
`JoyPort6Device`
  Set the device attached to: joystick adapter port 4 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) Sid Cartridge on the Plus4 (xplus4) (section 6.7.3 Control port and devices).
`JoyPort7Device`
  Set the device attached to: joystick adapter port 5 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (section 6.7.3 Control port and devices).
`JoyPort8Device`
  Set the device attached to: joystick adapter port 6 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (section 6.7.3 Control port and devices).
`JoyPort9Device`
  Set the device attached to: joystick adapter port 7 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (section 6.7.3 Control port and devices).
`JoyPort10Device`
  Set the device attached to: joystick adapter port 8 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (section 6.7.3 Control port and devices).
`JoyPort11Device`
  Set the device attached to: joystick adapter port 9 (xplus4) (section 6.7.3 Control port and devices).
`BBRTCSave`
  Enable saving of the battery-backed real time clock data.

### 6.7.2 Control port command-line options

`-controlport1device <device>`
  Set the device attached to: control port 1 (x64, x64sc, x64dtv, xscpu64, x128, xcbm5x0, xplus4) control port (xvic) (`JoyPort1Device`) (section 6.7.3 Control port and devices).
`-controlport2device <device>`
  Set the device attached to: control port 2 (x64, x64sc, x64dtv, xscpu64, x128, xcbm5x0, xplus4) (`JoyPort2Device`) (section 6.7.3 Control port and devices).
`-controlport3device <device>`
  Set the device attached to: joystick adapter port 1 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xpet, xvic, xplus4) (`JoyPort3Device`) (section 6.7.3 Control port and devices).
`-controlport4device <device>`
  Set the device attached to: joystick adapter port 2 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xpet, xvic, xplus4) (`JoyPort4Device`) (section 6.7.3 Control port and devices).
`-controlport5device <device>`
  Set the device attached to: joystick adapter port 3 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xpet, xvic, xplus4) (`JoyPort5Device`) (section 6.7.3 Control port and devices).
`-controlport6device <device>`
  Set the device attached to: joystick adapter port 4 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) Sid Cartridge on the Plus4 (xplus4) (`JoyPort6Device`) (section 6.7.3 Control port and devices).
`-controlport7device <device>`
  Set the device attached to: joystick adapter port 5 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (`JoyPort7Device`) (section 6.7.3 Control port and devices).
`-controlport8device <device>`
  Set the device attached to: joystick adapter port 6 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (`JoyPort8Device`) (section 6.7.3 Control port and devices).
`-controlport9device <device>`
  Set the device attached to: joystick adapter port 7 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (`JoyPort9Device`) (section 6.7.3 Control port and devices).
`-controlport10device <device>`
  Set the device attached to: joystick adapter port 8 (x64, x64sc, xscpu64, x128, x64dtv, xcbm2, xcbm5x0, xvic) (`JoyPort10Device`) (section 6.7.3 Control port and devices).
`-controlport11device <device>`
  Set the device attached to: joystick adapter port 9 (xplus4) (`JoyPort11Device`) (section 6.7.3 Control port and devices).
`-bbrtcsave`
`+bbrtcsave`
  Enable/Disable saving of the battery-backed real time clock data (`BBRTCSave`).

### 6.7.3 Control port and devices

x64/x64sc/xscpu64 control ports and devices:

nr | device | N1 | N2 | I1 | I2 | I3 | I4 | I5 | I6 | I7 | I8 | E1 | E2 | E3 | E4 | E5 | E6 | E7 | E8
0 | None | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
1 | Joystick | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
2 | Paddles | X | X
3 | Mouse (1351) | X | X
4 | Mouse (NEOS) | X | X
5 | Mouse (AMIGA) | X | X | X | X | X | X | X | X | X | X
6 | Trackball (CX22) | X | X | X | X | X | X | X | X | X | X
7 | Mouse (ST) | X | X | X | X | X | X | X | X | X | X
8 | Mouse (SmartMouse) | X | X
9 | Mouse (Micromys) | X | X
10 | KoalaPad | X | X
11 | Lightpen (up trigger) | X
12 | Lightpen (left trigger) | X
13 | Lightpen (Datel) | X
14 | Lightgun (Magnum Phaser) | X
15 | Lightgun (Stack Rifle) | X
16 | Lightpen (Inkwell) | X
18 | Sampler (2bit) | X | X | X | X | X | X | X | X | X | X
19 | Sampler (4bit) | X | X | X | X | X | X | X | X | X | X
20 | RTC (BBRTC) | X | X
21 | Dongle (Paperclip64D) | X | X
22 | Keypad (Coplin) | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
23 | Keypad (Cardco) | X | X
24 | Keypad (CX85) | X | X
25 | Keypad (RushWare) | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
26 | Keypad (CX21) | X | X
27 | Dongle (Script 64) | X | X
28 | Dongle (VizaWrite 64) | X | X
29 | Dongle (WaaSoft) | X | X
30 | SNES Pad (TrapThem) | X | X
31 | SNES Pad (Ninja) | X | X
32 | Spaceballs joy adapter | X | X
33 | Inception joy adapter | X | X
34 | MultiJoy adapter | X | X
36 | ProtoPad | X | X
37 | I/O Simulation device | X | X
38 | Microflyte joystick | X | X
39 | Dongle (Paperclip64E) | X | X
40 | Dongle (Paperclip64SC) | X | X
41 | Dongle (Paperclip2) | X | X
42 | Chalkboard Powerpad | X | X

x128 control ports and devices:

nr | device | N1 | N2 | I1 | I2 | I3 | I4 | I5 | I6 | I7 | I8 | E1 | E2 | E3 | E4 | E5 | E6 | E7 | E8
0 | None | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
1 | Joystick | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
2 | Paddles | X | X
3 | Mouse (1351) | X | X
4 | Mouse (NEOS) | X | X
5 | Mouse (AMIGA) | X | X | X | X | X | X | X | X | X | X
6 | Trackball (CX22) | X | X | X | X | X | X | X | X | X | X
7 | Mouse (ST) | X | X | X | X | X | X | X | X | X | X
8 | Mouse (SmartMouse) | X | X
9 | Mouse (Micromys) | X | X
10 | KoalaPad | X | X
11 | Lightpen (up trigger) | X
12 | Lightpen (left trigger) | X
13 | Lightpen (Datel) | X
14 | Lightgun (Magnum Phaser) | X
15 | Lightgun (Stack Rifle) | X
16 | Lightpen (Inkwell) | X
18 | Sampler (2bit) | X | X | X | X | X | X | X | X | X | X
19 | Sampler (4bit) | X | X | X | X | X | X | X | X | X | X
20 | RTC (BBRTC) | X | X
21 | Dongle (Paperclip64D) | X | X
27 | Dongle (Script 64) | X | X
28 | Dongle (VizaWrite 64) | X | X
29 | Dongle (WaaSoft) | X | X
30 | SNES Pad (TrapThem) | X | X
31 | SNES Pad (Ninja) | X | X
32 | Spaceballs joy adapter | X | X
33 | Inception joy adapter | X | X
34 | MultiJoy adapter | X | X
36 | ProtoPad | X | X
37 | I/O Simulation device | X | X
38 | Microflyte joystick | X | X
39 | Dongle (Paperclip64E) | X | X
40 | Dongle (Paperclip64SC) | X | X
41 | Dongle (Paperclip2) | X | X
42 | Chalkboard Powerpad | X | X

x64dtv control ports and devices:

nr | device | N1 | N2 | E1
0 | None | X | X | X
1 | Joystick | X | X | X
22 | Keypad (Coplin) | X | X | X
25 | Keypad (RushWare) | X | X | X
37 | I/O Simulation device | X | X

xcbm2/xpet can handle the following devices on all control ports:

nr | device
0 | None
1 | Joystick

xcbm5x0 control ports and devices:

nr | device | N1 | N2 | I1 | I2 | I3 | I4 | I5 | I6 | I7 | I8 | E1 | E2 | E3 | E4 | E5 | E6 | E7 | E8
0 | None | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
1 | Joystick | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
2 | Paddles | X | X
3 | Mouse (1351) | X | X
4 | Mouse (NEOS) | X | X
5 | Mouse (AMIGA) | X | X | X | X | X | X | X | X | X | X
6 | Trackball (CX22) | X | X | X | X | X | X | X | X | X | X
7 | Mouse (ST) | X | X | X | X | X | X | X | X | X | X
8 | Mouse (SmartMouse) | X | X
9 | Mouse (Micromys) | X | X
10 | KoalaPad | X | X
18 | Sampler (2bit) | X | X | X | X | X | X | X | X | X | X
19 | Sampler (4bit) | X | X | X | X | X | X | X | X | X | X
20 | RTC (BBRTC) | X | X
30 | SNES Pad (TrapThem) | X | X
31 | SNES Pad (Ninja) | X | X
33 | Inception joy adapter | X | X
34 | MultiJoy adapter | X | X
36 | ProtoPad | X | X
37 | I/O Simulation device | X | X
38 | Microflyte joystick | X | X

xplus4 control ports and devices:

nr | device | N1 | N2 | E1 | E2 | E3 | E4 | E5 | E6 | E7 | E8 | SC
0 | None | X | X | X | X | X | X | X | X | X | X | X
1 | Joystick | X | X | X | X | X | X | X | X | X | X | X
2 | Paddles |  |  |  |  |  |  |  |  |  |  | X
3 | Mouse (1351) |  |  |  |  |  |  |  |  |  |  | X
4 | Mouse (NEOS) |  |  |  |  |  |  |  |  |  |  | X
5 | Mouse (AMIGA) | X | X |  |  |  |  |  |  |  |  | X
6 | Trackball (CX22) | X | X |  |  |  |  |  |  |  |  | X
7 | Mouse (ST) | X | X |  |  |  |  |  |  |  |  | X
8 | Mouse (SmartMouse) |  |  |  |  |  |  |  |  |  |  | X
9 | Mouse (Micromys) |  |  |  |  |  |  |  |  |  |  | X
10 | KoalaPad |  |  |  |  |  |  |  |  |  |  | X
18 | Sampler (2bit) | X | X |  |  |  |  |  |  |  |  | X
19 | Sampler (4bit) | X | X |  |  |  |  |  |  |  |  | X
20 | RTC (BBRTC) |  |  |  |  |  |  |  |  |  |  | X
22 | Keypad (Coplin) | X | X |  |  |  |  |  |  |  |  | X
23 | Keypad (Cardco) |  |  |  |  |  |  |  |  |  |  | X
24 | Keypad (CX85) |  |  |  |  |  |  |  |  |  |  | X
25 | Keypad (RushWare) | X | X |  |  |  |  |  |  |  |  | X
26 | Keypad (CX21) |  |  |  |  |  |  |  |  |  |  | X
30 | SNES Pad (TrapThem) |  |  |  |  |  |  |  |  |  |  | X
36 | ProtoPad |  |  |  |  |  |  |  |  |  |  | X
37 | I/O Simulation device | X | X
38 | Microflyte joystick |  |  |  |  |  |  |  |  |  |  | X
42 | Chalkboard Powerpad |  |  |  |  |  |  |  |  |  |  | X

xvic control ports and devices:

nr | device | N1 | I1 | I2 | I3 | I4 | I5 | I6 | I7 | I8 | E1 | E2 | E3 | E4 | E5 | E6 | E7 | E8
0 | None | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
1 | Joystick | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X | X
2 | Paddles | X
3 | Mouse (1351) | X
4 | Mouse (NEOS) | X
5 | Mouse (AMIGA) | X | X | X | X | X | X | X | X | X
6 | Trackball (CX22) | X | X | X | X | X | X | X | X | X
7 | Mouse (ST) | X | X | X | X | X | X | X | X | X
8 | Mouse (SmartMouse) | X
9 | Mouse (Micromys) | X
10 | KoalaPad | X
11 | Lightpen (up trigger) | X
12 | Lightpen (left trigger) | X
13 | Lightpen (Datel) | X
14 | Lightgun (Magnum Phaser) | X
15 | Lightgun (Stack Rifle) | X
16 | Lightpen (Inkwell) | X
18 | Sampler (2bit) | X | X | X | X | X | X | X | X | X
19 | Sampler (4bit) | X | X | X | X | X | X | X | X | X
20 | RTC (BBRTC) | X
22 | Keypad (Coplin) | X | X | X | X | X | X | X | X | X
23 | Keypad (Cardco) | X
24 | Keypad (CX85) | X
25 | Keypad (RushWare) | X | X | X | X | X | X | X | X | X
26 | Keypad (CX21) | X
30 | SNES Pad (TrapThem) | X
31 | SNES Pad (Ninja) | X
32 | Spaceballs joy adapter | X
33 | Inception joy adapter | X
36 | ProtoPad | X
37 | I/O Simulation device | X
38 | Microflyte joystick | X
42 | Chalkboard Powerpad | X

Meaning of abreviations used in the tables above:

abr | meaning
N1 | Native control port 1
N2 | Native control port 2
I1 | Inception Joystick adapter port 1
I2 | Inception Joystick adapter port 2
I3 | Inception Joystick adapter port 3
I4 | Inception Joystick adapter port 4
I5 | Inception Joystick adapter port 5
I6 | Inception Joystick adapter port 6
I7 | Inception Joystick adapter port 7
I8 | Inception Joystick adapter port 8
E1 | Other Joystick adapter port 1
E2 | Other Joystick adapter port 2
E3 | Other Joystick adapter port 3
E4 | Other Joystick adapter port 4
E5 | Other Joystick adapter port 5
E6 | Other Joystick adapter port 6
E7 | Other Joystick adapter port 7
E8 | Other Joystick adapter port 8
SC | xplus4 SidCart joystick port

## 6.8 Joystick settings

### 6.8.1 Joystick resources

`JoyDevice1`
`JoyDevice2`
`JoyDevice3`
`JoyDevice4`
`JoyDevice5`
`JoyDevice6`
`JoyDevice7`
`JoyDevice8`
`JoyDevice9`
`JoyDevice10`
`JoyDevice11`
  Integer specifying which joystick device the emulator should use for joystick emulation for ports 1 - 10, respectively. (0=None, 1=Joystick 1, 2=Joystick 2, 4=Numpad, 8=Keyset 1, 16=Keyset 2 on OS/2) (0=None, 1=Numpad, 2=Keyset 1, 3=Keyset 2, 4=HID joystick 0, 5=HID joystick 1 on Mac OS X) The available joysticks might differ depending on operating system and joystick support in the OS (Linux joystick module must be available for example).
`JoyStick1AutoFire`
`JoyStick2AutoFire`
`JoyStick3AutoFire`
`JoyStick4AutoFire`
`JoyStick5AutoFire`
`JoyStick6AutoFire`
`JoyStick7AutoFire`
`JoyStick8AutoFire`
`JoyStick9AutoFire`
`JoyStick10AutoFire`
`JoyStick11AutoFire`
  Boolean, enables autofire for joystick emulation for ports 1 - 10, respectively. (0=Off, 1=On)
`JoyStick1AutoFireMode`
`JoyStick2AutoFireMode`
`JoyStick3AutoFireMode`
`JoyStick4AutoFireMode`
`JoyStick5AutoFireMode`
`JoyStick6AutoFireMode`
`JoyStick7AutoFireMode`
`JoyStick8AutoFireMode`
`JoyStick9AutoFireMode`
`JoyStick10AutoFireMode`
`JoyStick11AutoFireMode`
  Integer specifying the autofire mode to be used for for joystick emulation for ports 1 - 10, respectively. (0=Autofire when fire is pressed, 1=Permanent autofire except when fire is pressed)
`JoyStick1AutoFireSpeed`
`JoyStick2AutoFireSpeed`
`JoyStick3AutoFireSpeed`
`JoyStick4AutoFireSpeed`
`JoyStick5AutoFireSpeed`
`JoyStick6AutoFireSpeed`
`JoyStick7AutoFireSpeed`
`JoyStick8AutoFireSpeed`
`JoyStick9AutoFireSpeed`
`JoyStick10AutoFireSpeed`
`JoyStick11AutoFireSpeed`
  Integer specifying the amount of fire button presses per second for autofire for joystick emulation for ports 1 - 10, respectively. (1-255)
`JoyOpposite`
  Boolean, if true allow (usually impossible) bitcombinations for opposite directions. (all emulators except vsid)
`Mouse`
  Boolean, enables mouse emulation
`SmartMouseRTCSave`
  Boolean, specified whether to save real time clock data for the SmartMouse
`PaddlesInput1`
  Integer speciftying the host input for the potentiometers of joystick port 1 (all emulators except xcbm2 and xpet) (0: Mouse, 1: Joystick axis)
`PaddlesInput2`
  Integer speciftying the host input for the potentiometers of joystick port 2 (all emulators except xcbm2, xplus4 and xvic) (0: Mouse, 1: Joystick axis)
`KeySet1NorthWest`
`KeySet1North`
`KeySet1NorthEast`
`KeySet1East`
`KeySet1SouthEast`
`KeySet1South`
`KeySet1SouthWest`
`KeySet1West`
`KeySet1Fire`
`KeySet1Fire2`
`KeySet1Fire3`
`KeySet1Fire4`
`KeySet1Fire5`
`KeySet1Fire6`
`KeySet1Fire7`
`KeySet1Fire8`
  Integers specifying the keycodes for keyset 1 (all emulators except vsid).
`KeySet2NorthWest`
`KeySet2North`
`KeySet2NorthEast`
`KeySet2East`
`KeySet2SouthEast`
`KeySet2South`
`KeySet2SouthWest`
`KeySet2West`
`KeySet2Fire`
`KeySet2Fire2`
`KeySet2Fire3`
`KeySet2Fire4`
`KeySet2Fire5`
`KeySet2Fire6`
`KeySet2Fire7`
`KeySet2Fire8`
  Integers specifying the keycodes for keyset 2 (all emulators except vsid).
`KeySetEnable`
  Boolean that specifies whether user defined keysets are enabled (all emulators except vsid).
`KbdbufDelay`
  Integer specifying the additional keyboard delay. (0: use default)

### 6.8.2 Joystick command-line options

`-joydev1 <range>`
`-joydev2 <range>`
  Set the device for joystick emulation of port 1 and 2, respectively. (`JoyDevice1`, `JoyDevice2`).
`-extrajoydev1 <0-8>`
`-extrajoydev2 <0-8>`
`-extrajoydev3 <0-8>`
`-extrajoydev4 <0-8>`
`-extrajoydev5 <0-8>`
`-extrajoydev6 <0-8>`
`-extrajoydev7 <0-8>`
`-extrajoydev8 <0-8>`
`-extrajoydev9 <0-8>`
  Set device for extra joystick port 1, 2, 3, 4, 5, 6, 7 and 8. (`JoyDevice3`, `JoyDevice4`, `JoyDevice5`, `JoyDevice6`, `JoyDevice7`, `JoyDevice8`, `JoyDevice9`, `JoyDevice10`, `JoyDevice11`).
`-joystick1autofire`
`+joystick1autofire`
  Enable/disable autofire for native joystick port 1 (`JoyStick1AutoFire=1`, `JoyStick1AutoFire=0`). (all emulators except xcbm2, xpet and vsid)
`-joystick2autofire`
`+joystick2autofire`
  Enable/disable autofire for native joystick port 2 (`JoyStick2AutoFire=1`, `JoyStick2AutoFire=0`). (all emulators except xcbm2, xpet, xvic and vsid)
`-extrajoystick1autofire`
`+extrajoystick1autofire`
  Enable/disable autofire for joystick adapter port 1 (`JoyStick3AutoFire=1`, `JoyStick3AutoFire=0`). (all emulators except vsid)
`-extrajoystick2autofire`
`+extrajoystick2autofire`
  Enable/disable autofire for joystick adapter port 2 (`JoyStick4AutoFire=1`, `JoyStick4AutoFire=0`). (all emulators except vsid)
`-extrajoystick3autofire`
`+extrajoystick3autofire`
  Enable/disable autofire for joystick adapter port 3 or plus4 sidcard joystick port (`JoyStick5AutoFire=1`, `JoyStick5AutoFire=0`). (all emulators except vsid)
`-extrajoystick4autofire`
`+extrajoystick4autofire`
  Enable/disable autofire for joystick adapter port 4 (`JoyStick6AutoFire=1`, `JoyStick6AutoFire=0`). (all emulators except vsid)
`-extrajoystick5autofire`
`+extrajoystick5autofire`
  Enable/disable autofire for joystick adapter port 5 (`JoyStick7AutoFire=1`, `JoyStick7AutoFire=0`). (all emulators except vsid)
`-extrajoystick6autofire`
`+extrajoystick6autofire`
  Enable/disable autofire for joystick adapter port 6 (`JoyStick8AutoFire=1`, `JoyStick8AutoFire=0`). (all emulators except vsid)
`-extrajoystick7autofire`
`+extrajoystick7autofire`
  Enable/disable autofire for joystick adapter port 7 (`JoyStick9AutoFire=1`, `JoyStick9AutoFire=0`). (all emulators except vsid)
`-extrajoystick8autofire`
`+extrajoystick8autofire`
  Enable/disable autofire for joystick adapter port 8 (`JoyStick10AutoFire=1`, `JoyStick10AutoFire=0`). (all emulators except vsid)
`-extrajoystick9autofire`
`+extrajoystick9autofire`
  Enable/disable autofire for joystick adapter port 9 (`JoyStick11AutoFire=1`, `JoyStick11AutoFire=0`). (xplus4 only)
`-joystick1autofiremode <Mode>`
  Set autofire mode for native joystick port 1 (`JoyStick1AutoFireMode`) (all emulators except xcbm2, xpet and vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-joystick2autofiremode <Mode>`
  Set autofire mode for native joystick port 2 (`JoyStick2AutoFireMode`) (all emulators except xcbm2, xpet, xvic and vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick1autofiremode <Mode>`
  Set autofire mode for joystick adapter port 1 (`JoyStick3AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick2autofiremode <Mode>`
  Set autofire mode for joystick adapter port 2 (`JoyStick4AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick3autofiremode <Mode>`
  Set autofire mode for joystick adapter port 3 or plus4 sidcard joystick port (`JoyStick5AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick4autofiremode <Mode>`
  Set autofire mode for joystick adapter port 4 (`JoyStick6AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick5autofiremode <Mode>`
  Set autofire mode for joystick adapter port 5 (`JoyStick7AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick6autofiremode <Mode>`
  Set autofire mode for joystick adapter port 6 (`JoyStick8AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick7autofiremode <Mode>`
  Set autofire mode for joystick adapter port 7 (`JoyStick9AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick8autofiremode <Mode>`
  Set autofire mode for joystick adapter port 8 (`JoyStick10AutoFireMode`) (all emulators except vsid). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-extrajoystick9autofiremode <Mode>`
  Set autofire mode for joystick adapter port 9 (`JoyStick11AutoFireMode`) (xplus4 only). (0: Autofire when fire is pressed, 1: Permanent autofire except when fire is pressed)
`-joystick1autofirespeed <1-255>`
`-joystick2autofirespeed <1-255>`
  Set the amount of presses per second for autofire for joystick emulation of port 1 and 2, respectively. (`JoyStick1AutoFireSpeed`, `JoyStick2AutoFireSpeed`).
`-extrajoystick1autofirespeed <1-255>`
`-extrajoystick2autofirespeed <1-255>`
`-extrajoystick3autofirespeed <1-255>`
`-extrajoystick4autofirespeed <1-255>`
`-extrajoystick5autofirespeed <1-255>`
`-extrajoystick6autofirespeed <1-255>`
`-extrajoystick7autofirespeed <1-255>`
`-extrajoystick8autofirespeed <1-255>`
`-extrajoystick9autofirespeed <1-255>`
  Set the amount of presses per second for autofire for extra joystick port 1, 2, 3, 4, 5, 6, 7, 8 and 9. (`JoyStick3AutoFireSpeed`, `JoyStick4AutoFireSpeed`, `JoyStick5AutoFireSpeed`, `JoyStick6AutoFireSpeed`, `JoyStick7AutoFireSpeed`, `JoyStick8AutoFireSpeed`, `JoyStick9AutoFireSpeed`, `JoyStick10AutoFireSpeed`, `JoyStick11AutoFireSpeed`).
`-joyopposite`
`+joyopposite`
  Enable/disable opposite joystick directions (`JoyOpposite=1`, `JoyOpposite=0`). (all emulators except vsid)
`-mouse`
`+mouse`
  Enable/Disable mouse grab
`-smartmousertcsave`
`+smartmousertcsave`
  Enable/Disable saving of the real time clock data for the SmartMouse (`SmartMouseRTCSave=1`, `SmartMouseRTCSave=0`)
`-paddles1inputmouse`
  Set the host input for the potentiometers of joystick port 1 to the mouse. (`PaddlesInput1=0`)
`-paddles1inputmouse`
  Set the host input for the potentiometers of joystick port 1 to a joystick axis. (`PaddlesInput1=1`)
`-paddles2inputmouse`
  Set the host input for the potentiometers of joystick port 2 to the mouse. (`PaddlesInput2=0`)
`-paddles2inputmouse`
  Set the host input for the potentiometers of joystick port 2 to a joystick axis. (`PaddlesInput2=1`)
`-keyset`
`+keyset`
  Enable/disable user defined keyset (`KeySetEnable=1`, `KeySetEnable=0`) (all emulators except vsid).
`-keybuf-delay <value>`
  Set additional keyboard buffer delay (`KbdbufDelay`). (0: use default)

## 6.9 Sound settings

The following menu items control sound output:

- "Enable sound playback" turns sound emulation on and off.
- "Sound synchronization" specifies the method for syncronizing the sound playback. Possible settings are:
  - "Flexible", i.e., the audio renderer flexibly adds/removes samples to the output to smoothly adapt the playback to slight changes in the speed of the emulator.
  - "Adjusting" works like "flexible", but supports bigger differences in speed. For example, if the emulation speed drops down from from 100% to 50%, audio slows down by the same amount too.
  - "Exact", instead, makes the audio renderer output always the same sounds you would hear from the real thing, without trying to adapt the ratio; to compensate the tolerances in speed, some extra frames will be skipped or added.
- "Sample rate" specifies the sampling frequency, ranging from 8000 to 48000 Hz (not all the sound cards and/or sound drivers can support all the frequencies, so actually the nearest candidate will be chosen).
- "Buffer size" specifies the size of the audio buffer; the bigger the buffer, the longer the delay with which sounds are played. You should pick the smallest value your machine can handle without problems.
- "Sound suspend time", will cause the audio playback to pause for the specified number of seconds whenever some clicking happens. If "Keep going" is selected, no pausing is done. The following menu items control sound input:
- "Sampler Device" specifies the host device/method used for sampling/sound input, currently portaudio (if linked in) and file methods are supported.
- "Sampler Gain" specifies the amount of gain (increase the input volume if above 100 or decrease the input volume if below 100) for the input of the sampler device.
- "Sampler File" specifies the name of the file to be uses as an input source for the 'file' method/device.

### 6.9.1 Sound resources

`Sound`
  Boolean specifying whether audio emulation is turned on.
`SoundEmulateOnWarp`
  Boolean specifying whether sound chips should be emulated in warp mode. (0: do not emulate sound chips in warp mode, 1: emulate sound chips also in warp mode)
`SoundSampleRate`
  Integer specifying the sampling frequency in Hz (not all the sound cards and/or sound drivers can support all the frequencies, so actually the nearest candidate will be chosen). (8000..48000)
`SoundBufferSize`
  Integer specifying the size of the audio buffer, in milliseconds.
`SoundDeviceName`
  String specifying the audio driver. Implemented drivers are:
  - `ahi`, for the Amiga/Morphos/Aros sound driver.
  - `aix`, for the IBM AIX sound driver.
  - `allegro`, for the DOS Allegro sound driver.
  - `alsa`, for the linux ALSA sound driver.
  - `arts`, for the *nix ARTS sound driver.
  - `beos`, for the BeOS/Zeta/Haiku sound driver.
  - `bsp`, for the BeOS/Zeta/Haiku BeOS Media Kit sound driver.
  - `coreaudio`, for the Mac OS X sound driver (`SoundDeviceArg` specifies the audio device, default system output by default).
  - `dart`, for the OS/2 sound driver.
  - `dummy`, fully emulating the sound output chip(s), but not actually playing samples.
  - `dx`, for the Windows Direct-X sound driver.
  - `hpux`, for the HP-UX audio device (unfinished; `SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default).
  - `midas`, for the DOS Midas sound driver.
  - `pulse`, for the Pulseaudio sound driver.
  - `sdl`, for the Simple DirectMedia Layer audio driver.
  - `sgi`, for the Silicon Graphics audio device (`SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default);
  - `speed`, like `dummy` but also calculating samples (mainly used to evaluate the speed of the sample generator);
  - `sun`, for the Solaris and NetBDS audio device (unfinished; `SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default).
  - `uss`, for the Linux/FreeBSD Universal Sound System driver (`SoundDeviceArg` specifies the audio device, ``/dev/dsp'` by default);
  - `wmm`, for the Windows Multimedia Waveout sound device.
  These drivers will actually be present only if the VICE configuration script detected the corresponding development support at the time of compilation.
`SoundDeviceArg`
  String specifying an additional parameter for the audio driver (see `SoundDeviceName`).
`SoundRecordDeviceName`
  String specifying the driver used for sound recording. Implemented drivers are:
  - `aiff`, for the Apple Interchange File Format 16bit sound recorder driver.
  - `dump`, writing all the write accesses to the registers to a file (specified by `SoundDeviceArg`, default value is `vicesnd.sid`);
  - `fs`, writing samples to a file (specified by `SoundDeviceArg`; default is ``vicesnd.raw'`); `iff`, for the Amiga Interchange File Format (8SVX) 8bit sound recorder driver.
  - `mp3`, for the MP3 sound recorder driver.
  - `flac`, for the FLAC sound recorder driver.
  - `ogg`, for the ogg/vorbis sound recorder driver.
  - `voc`, for the Creative Voice (VOC) sound recorder driver.
  - `wav`, for the RIFF/WAV sound recorder driver.
  These drivers will actually be present only if the VICE configuration script detected the corresponding development support at the time of compilation.
`SoundRecordDeviceArg`
  String specifying additional arguments for sound recording.
`SoundFragmentSize`
  Integer specifying the fragment size. (0: very small, 1: small, 2: medium, 3: large, 4: very large)
`SoundVolume`
  Integer specifying the master volume in percent. (0..100)
`SoundOutput`
  Integer specifying the type of sound output. Output is selectable between 'system' (system decides to use mono or stereo output based on the presence of a stereo sid), 'always mono' (output is always mono, stereo streams are mixed into a mono stream) or 'always stereo' (output is always stereo, mono streams are multiplexed to a stereo stream). (0: system, 1: mono, 2: stereo)
`SamplerDevice`
  Integer specifying the device/method to be used for sound input. (0: sample file device, 1: PortAudio device)
`SamplerGain`
  Integer specifying the gain to be used for sound input. (>100 increase input volume, <100: decrease input volume)
`SampleName`
  String specifying the name of the file/sample to be used as the input source for the 'file' sampler device.

### 6.9.2 Sound command-line options

`-sound`
`+sound`
  Enable/disable sound emulation (`Sound=1`, `Sound=0`).
`-soundwarpmode <mode>`
  Specify if sound chips should be emulated in warp mode. (`SoundEmulateOnWarp`). (0: do not emulate sound chips in warp mode, 1: emulate sound chips also in warp mode)
`-soundrate <value>`
  Specify the sound playback sample rate (`SoundSampleRate`). (8000..48000)
`-soundoutput <output mode>`
  Sound output mode (`SoundOutput`). (0: system decides mono/stereo, 1: always mono, 2: always stereo)
`-soundbufsize <value>`
  Specify the size of the audio buffer in milliseconds (`SoundBufferSize`).
`-soundfragsize <value>`
  Set sound fragment size (`SoundFragmentSize`). (0: very small, 1: small, 2: medium, 3: large, 4: very large)
`-sounddev <Name>`
  Specifies the name of the audio device (`SoundDeviceName`). (ahi, aix, allegro, alsa, arts, beos, bsp, coreaudio, dart, dummy, dx, hpux, midas, pulse, sdl, sgi, sun, uss, wmm)
`-soundarg <args>`
  Specifies an additional parameter for the audio device (`SoundDeviceArg`).
`-soundrecdev <name>`
  Specify recording sound driver (`SoundRecordDeviceName`). (aiff, dump, fs, iff, mp3, flac, ogg, speed, voc, wav)
`-soundrecarg <args>`
  Specify initialization parameters for recording sound driver (`SoundRecordDeviceArg`).
`-soundvolume <volume>`
  Specify the sound volume (`SoundVolume`). (0..100)
`-samplerdev <device number>`
  Specify the device to use for audio input (`SamplerDevice`). (0: file device, 1: portaudio device)
`-samplergain <percent>`
  Specify the amount of gain (volume increase/decrease) for the audio input device (`SamplerGain`). (0..200)
`-samplename <name>`
  Specify the name of the file to use for the 'file' audio input device (`SampleFile`).

## 6.10 Tape settings

These settings are used to control the hardware-level emulation of the Tape drive.

### 6.10.1 Tape resources

`DatasetteResetWithCPU`
  Boolean specifying whether to reset (rewind) the tape when resetting the CPU.
`DatasetteZeroGapDelay`
  Integer specifying the delay in cycles for a zero gap length in the tap. Mostly relevant for v0 .tap files which could not properly encode gaps > 255. The default is 2500, which is what "mtap" is using.
`DatasetteSpeedTuning`
  Integer specifying the deviation from the correct motor speed. 100000 equals 100% deviation. Default is 0.
`DatasetteTapeWobbleFrequency`
  Integer specifying the tape wobble frequency. 1000 equals 1Hz, default is 3Hz.
`DatasetteTapeWobbleAmplitude`
  Integer specifying the tape wobble amplitude. 100000 equals 100% deviation of the correct motor speed. Default is 0.5%.
`DatasetteTapeAzimuthError`
  Integer specifying the amount of azimuth alignment error. This is right now very inaccurately simulated by adding a random amount of cycles. 1000 equals +/- one cycle. Default is 0.
`DatasetteSound`
  Boolean specifying whether to produce audible sound when playing a tape on the datasette
`DatasetteSoundVolume`
  Integer specifying the volume of the tape sound. Meaningful values are in the range 1-32767

### 6.10.2 Tape command-line options

`-dsresetwithcpu`
`+dsresetwithcpu`
  Enable/disable automatic Datasette-Reset (`DatasetteResetWithCPU=1`, `DatasetteResetWithCPU=0`).
`-dszerogapdelay <value>`
  Set delay in cycles for a zero gap in the tap. Mostly relevant for v0 .tap files which could not properly encode gaps > 255. (`DatasetteZeroGapDelay`).
`-dsspeedtuning <value>`
  Set amount of deviation from the correct motor speed. 100000 equals 100% deviation. (`DatasetteSpeedTuning`).
`-dstapewobblefreq <value>`
  Set tape wobble frequency. 1000 equals 1Hz, default is 3Hz. (`DatasetteTapeWobbleFrequency`).
`-dstapewobbleamp <value>`
  Set tape wobble amplitude. 100000 equals 100% deviation of the correct motor speed. (`DatasetteTapeWobbleAmplitude`).
`-dstapeerror <value>`
  Set tape alignment error. This is right now very inaccurately simulated by adding a random amount of cycles. 1000 equals +/- one cycle. (`DatasetteTapeAzimuthError`).
`-datasettesound`
`+datasettesound`
  Enable/disable Datasette sound emulation (`DatasetteSound=1`, `DatasetteSound=0`).
`-dssoundvolume <value>`
  Set the volume of the Datasette sound (`DatasetteSoundVolume`).

## 6.11 Drive settings

These settings are used to control the hardware-level emulation of the Disk drives. When hardware-level emulation is turned on, only drives 8 and 9 are being emulated.

The following settings affect both drives:

- "Enable true drive emulation" enables the (slow) hardware-level emulation of the drives for maximum compatibility. This must be turned on for any of the following settings to have effect.
- "Drive sync factor" specifies the speed of the drive's CPU. This can be used to help loading certain programs that have trouble with the default PAL setting (for example, programs designed for NTSC machines). The ratio is calculated as follows:

      sync_factor = 65536 * clk_drive / clk_machine

  where `clk_drive` and `clk_machine` are clock speeds in MHz. The menu lets you choose between the PAL and NTSC values, and also lets you specify whatever value you want. Be careful when changing it, though, because a wrong value can break things and even corrupt disk images.

The following settings, instead, are specific of each drive:

- "Drive model" specifies the model of the drive being emulated. Warning: This will reset the drive.
- "Enable parallel cable" enables emulation of a SpeedDOS parallel cable; if you switch this option on and replace the original Commodore ROMs with SpeedDOS-compatible ones, you can speed up loading/saving times.
- "Idle method" specifies which method the drive emulation should use to save CPU cycles in the host CPU. There are three methods:
  - Skip cycles: Each time the serial line is accessed by the C64, the drive executes all the cycles since the last time it ran. If the number of elapsed cycles is larger than a certain value, the drive discards part of them.
  - Trap idle: The disk drive is still emulated upon serial line accesses as with the previous option, but it is also always emulated at the end of each screen frame. If the drive gets into the DOS idle loop, only pending interrupts are emulated to save time.
  - No traps: Like "Trap idle", but without any traps at all. So basically the drive works exactly as with the real thing, and nothing is done to reduce the power needs of the drive emulation.
  The first option ("Skip cycles") is usually best for performance, as the drive is emulated as little as possible; on the other hand, you may notice sudden slowdowns (when the drive executes several cycles at once) and the LED status is never updated (because it would not be possible to do correctly so). Moreover, if the drive tries to get in sync with the computer in some weird way and the computer does not access the serial line for a long time, it is possible that some cycles are discarded and the sync is lost. Notice that this hack will have no effect on performance if a program continuously reads from the IEC port, as the drive will have to be fully emulated in any case (some stupid programs do this, even when they don't actually need to use the drive).

  The second option ("Trap idle") is usually a bit slower, as at least interrupts are always emulated, but ensures the LED state is always updated correctly and always keeps the drive and the computer in sync. On the other hand, if a program installs a non-standard idle loop in the drive, the drive CPU has to be emulated even when not necessary and the global emulation speed is then much slower.

- "40-track image support" specifies how 40-track ("extended") disk images should be supported. There are three possible ways:
  - "Never extend" never extends disk images at all (so if a program tries to write tracks beyond the 35th, it is not allowed to do so);
  - "Ask on extend" prompts the user as soon as a program tries to write tracks beyond the 35th, and the user can then choose whether he wants the disk image to be extended or not;
  - "Extend on access" simply extends the disk image as soon the program needs it, without prompting the user.

### 6.11.1 Drive resources

`Drive8TrueEmulation`
`Drive9TrueEmulation`
`Drive10TrueEmulation`
`Drive11TrueEmulation`
  Boolean controlling whether the "true" drive emulation is turned on.
`DriveSoundEmulation`
  Boolean controlling whether the drive noise emulation is turned on (all emulators except vsid).
`DriveSoundEmulationVolume`
  Integer specifying the volume of the drive noise emulation (all emulators except vsid). (0..4000, 4000 equals 100.0%.)
`Drive8Type`
`Drive9Type`
`Drive10Type`
`Drive11Type`
  Integers specifying the model number for drives 8 to 11. Possible values are `1541` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1542` (1541-II) [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1570` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1571` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1573` (1571CR) [x128 only], `1551` [xplus4 only], `1581` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1001` [all emulators except x64dtv, xplus4 and vsid], `2000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `2031` [all emulators except x64dtv, xplus4 and vsid], `2040` [all emulators except x64dtv, xplus4 and vsid], `3040` [all emulators except x64dtv, xplus4 and vsid], `4000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `4040` [all emulators except x64dtv, xplus4 and vsid], `4844` (CMD HD) [all emulators except xcbm2, xcbm5x0, xpet and vsid], `8050` [all emulators except x64dtv, xplus4 and vsid], `8250` [all emulators except x64dtv, xplus4 and vsid]. `9000` [all emulators except x64dtv, xplus4 and vsid].
`Drive8RTCSave`
`Drive9RTCSave`
`Drive10RTCSave`
`Drive11RTCSave`
  Integer specifying whether the RTC data of drive 8 to 11 should be saved when changed or not (drive type 2000/4000/4844 only).
`Drive8ParallelCable`
`Drive9ParallelCable`
`Drive10ParallelCable`
`Drive11ParallelCable`
  integers controlling what type of parallel cable is emulated for drives 8 to 11 (x64, x64sc, xscpu64, x128 and xplus4 only). x64, x64sc, xscpu64, x128: (0: None, 1: Standard, 2: Dolphin DOS 3, 3: Formel64) xplus4: (0: None, 1: Standard)
`Drive8ProfDOS`
`Drive9ProfDOS`
`Drive10ProfDOS`
`Drive11ProfDOS`
  Booleans controlling whether Professional DOS is emulated or not for drives 8 to 11 (x64, x64sc, xscpu64 and x128 only).
`Drive8SuperCard`
`Drive9SuperCard`
`Drive10SuperCard`
`Drive11SuperCard`
  Booleans controlling whether Supercard is emulated or not for drives 8 to 11 (x64, x64sc, xscpu64 and x128 only).
`Drive8StarDos`
`Drive9StarDos`
`Drive10StarDos`
`Drive11StarDos`
  Booleans controlling whether StarDOS is emulated or not for drives 8 to 11 (x64, x64sc, xscpu64 and x128 only).
`Drive8RAM2000`
`Drive9RAM2000`
`Drive10RAM2000`
`Drive11RAM2000`
  Booleans controlling whether a RAM block is emulated at $2000-$3FFF for drive 8 to 11.
`Drive8RAM4000`
`Drive9RAM4000`
`Drive10RAM4000`
`Drive11RAM4000`
  Booleans controlling whether a RAM block is emulated at $4000-$5FFF for drive 8 to 11.
`Drive8RAM6000`
`Drive9RAM6000`
`Drive10RAM6000`
`Drive11RAM6000`
  Booleans controlling whether a RAM block is emulated at $6000-$7FFF for drive 8 to 11.
`Drive8RAM8000`
`Drive9RAM8000`
`Drive10RAM8000`
`Drive11RAM8000`
  Booleans controlling whether a RAM block is emulated at $8000-$9FFF for drive 8 to 11.
`Drive8RAMA000`
`Drive9RAMA000`
`Drive10RAMA000`
`Drive11RAMA000`
  Booleans controlling whether a RAM block is emulated at $A000-$BFFF for drive 8 to 11.
`Drive8ExtendImagePolicy`
`Drive9ExtendImagePolicy`
`Drive10ExtendImagePolicy`
`Drive11ExtendImagePolicy`
  Integer specifying the policy for 40-track support for drives 8 to 11. (0: never extend, 1: ask on extend, 2: extend on access)
`Drive8IdleMethod`
`Drive9IdleMethod`
`Drive10IdleMethod`
`Drive11IdleMethod`
  Integers specifying the idling method for the drive CPU. See section 6.11 Drive settings. (0: none, 1: skip cycles, 2: trap idle)
`Drive8RPM`
`Drive9RPM`
`Drive10RPM`
`Drive11RPM`
  Integers specifying the rotation speed of the drive, multiplied by 100, so 300rpm equals 30000.
`Drive8WobbleFrequency`
`Drive9WobbleFrequency`
`Drive10WobbleFrequency`
`Drive11WobbleFrequency`
  Integers specifying the drive wobble frequency. 1000 equals 1Hz.
`Drive8WobbleAmplitude`
`Drive9WobbleAmplitude`
`Drive10WobbleAmplitude`
`Drive11WobbleAmplitude`
  Integers specifying the drive wobble amplitude. 1000 equals +/- 1 RPM.
`Drive8FixedSize`
`Drive9FixedSize`
`Drive10FixedSize`
`Drive11FixedSize`
  Integer specifying the size of the diskimage (in bytes) returned to SCSI capacity inquiries for CMD HDs. A disk image must be attached for a valid size to be returned. A value of "0" will report back the current image size. Values may also be followed by the suffix "K", "M", or "G" for kilobyte, megabyte, and gigabyte respectively. Default is "8G".
`DosName1540`
`DosName1541`
`DosName1541ii`
`DosName1570`
`DosName1571`
`DosName1581`
`DosName2000`
`DosName4000`
`DosNameCMDHD`
  Strings specifying the names of the ROM images for the drive emulation. (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`DosName1551`
  String specifying the name of the ROM image for the drive emulation. (xplus4 only)
`DosName1571cr`
  String specifying the name of the ROM image for the drive emulation. (x128 only)
`DosName2031`
`DosName2040`
`DosName3040`
`DosName4040`
`DosName1001`
`DosName9000`
  Strings specifying the names of the ROM images for the drive emulation. (all emulators except x64dtv, xplus4 and vsid)
`DriveProfDOS1571Name`
  String specifying the filename of the 1571 professional DOS ROM image (x64, x64sc, xscpu64 and x128 only).
`DriveSuperCardName`
  String specifying the filename of the Supercard ROM image (x64, x64sc, xscpu64 and x128 only).
`DriveStarDosName`
  String specifying the filename of the image of the lower half of the StarDOS ROM (x64, x64sc, xscpu64 and x128 only).
`FliplistName`
  String specifying the filename of the current flip list. (Drive 8 only) (all emulators except vsid).
`AttachDevice8d0Readonly`
`AttachDevice9d0Readonly`
`AttachDevice10d0Readonly`
`AttachDevice11d0Readonly`
  Booleans that specify whether to attach images on drives 8 to 11 read-only or not (all emulators except vsid).
`AttachDevice8d1Readonly`
`AttachDevice9d1Readonly`
`AttachDevice10d1Readonly`
`AttachDevice11d1Readonly`
  Booleans that specify whether to attach images on the second drive of dual-drives 8 to 11 read-only or not (all emulators except vsid).

### 6.11.2 Drive command-line options

`-drive8truedrive, +drive8truedrive`
`-drive9truedrive, +drive9truedrive`
`-drive10truedrive, +drive10truedrive`
`-drive11truedrive, +drive11truedrive`
  Enable/disable true drive emulation (`Drive8TrueEmulation=1`, `Drive8TrueEmulation=0`, `Drive9TrueEmulation=1`, `Drive9TrueEmulation=0`, `Drive10TrueEmulation=1`, `Drive10TrueEmulation=0`, `Drive11TrueEmulation=1`, `Drive11TrueEmulation=0`).
`-drivesound`
`+drivesound`
  Enable/disable drive sound emulation (`DriveSoundEmulation=1`, `DriveSoundEmulation=0`) (all emulators except vsid).
`-drivesoundvolume <Volume>`
  Set the volume of the drive sound emulation. (4000 equals 100.0%.) (`DriveSoundEmulationVolume=0..4000`) (all emulators except vsid).
`-drive8type <Type>`
`-drive9type <Type>`
`-drive10type <Type>`
`-drive11type <Type>`
  Specifies the drive types for drives 8-11, respectively. Possible values for `TYPE` are `1541` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1542` (meaning 1541-II) [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1551` [xplus4 only], `1570` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1571` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1573` (meaning 1571cr) [x128 only], `1581` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `2000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `4000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `4844` (meaning CMD HD) [all emulators except xcbm2, xcbm5x0, xpet and vsid], `2031` [all emulators except x64dtv, xplus4 and vsid], `2040` [all emulators except x64dtv, xplus4 and vsid], `3040` [all emulators except x64dtv, xplus4 and vsid], `4040` [all emulators except x64dtv, xplus4 and vsid], `1001` [all emulators except x64dtv, xplus4 and vsid], `8050` [all emulators except x64dtv, xplus4 and vsid] `8250` [all emulators except x64dtv, xplus4 and vsid]. and `9000` [all emulators except x64dtv, xplus4 and vsid].
`-drive8rtcsave, +drive8rtcsave`
`-drive9rtcsave, +drive9rtcsave`
`-drive10rtcsave, +drive10rtcsave`
`-drive11rtcsave, +drive11rtcsave`
  Enable/disable the saving of the RTC data for drive 8 to 11 when changed (drive type 2000/4000/4844 only) (`Drive8RTCSave=1`, `Drive8RTCSave=0`, `Drive9RTCSave=1`, `Drive9RTCSave=0`, `Drive10RTCSave=1`, `Drive10RTCSave=0`, `Drive11RTCSave=1`, `Drive11RTCSave=0`).
`-parallel8 <type>`
`-parallel9 <type>`
`-parallel10 <type>`
`-parallel11 <type>`
  Set parallel cable type for drives 8-11 respectively (`Drive8ParallelCable`, `Drive9ParallelCable`, `Drive10ParallelCable`, `Drive11ParallelCable`) (x64, x64sc, xscpu64, x128 and xplus4 only). x64, x64sc, xscpu64, x128: (0: None, 1: Standard, 2: Professional DOS, 3: Formel64) xplus4: (0: None, 1: Standard)
`-drive8idle <method>`
`-drive9idle <method>`
`-drive10idle <method>`
`-drive11idle <method>`
  Specifies <method> as the idling method for drives 8-11 respectively (`Drive8IdleMethod`, `Drive9IdleMethod`, `Drive10IdleMethod`), `Drive11IdleMethod`). (0: none, 1: skip cycles, 2: trap idle)
`-drive8extend <method>`
`-drive9extend <method>`
`-drive10extend <method>`
`-drive11extend <method>`
  Specifies <method> as the track 40 extend policy in drives 8-11 respectively (`Drive8ExtendImagePolicy`, `Drive9ExtendImagePolicy`, `Drive10ExtendImagePolicy`, `Drive11ExtendImagePolicy`). (0: never extend, 1: ask on extend, 2: extend on access)
`-drive8rpm <rpm>`
`-drive9rpm <rpm>`
`-drive10rpm <rpm>`
`-drive11rpm <rpm>`
  Specifies the rotation speed of the drive, multiplied by 100 so 300rpm equal 30000.
`-drive8wobblefrequency <frequency>`
`-drive9wobblefrequency <frequency>`
`-drive10wobblefrequency <frequency>`
`-drive11wobblefrequency <frequency>`
  Specifies frequency of the drive wobble. 1000 equals 1Hz.
`-drive8wobbleamplitude <amplitude>`
`-drive9wobbleamplitude <amplitude>`
`-drive10wobbleamplitude <amplitude>`
`-drive11wobbleamplitude <amplitude>`
  Specifies amplitude of the drive wobble. 1000 equals +/- 1RPM.
`-drive8fixedsize`
`-drive9fixedsize`
`-drive10fixedsize`
`-drive11fixedsize`
  Specifies the size of the diskimage (in bytes) returned to SCSI capacity inquiries for CMD HDs. A disk image must be attached for a valid size to be returned. A value of "0" will report back the current image size. Values may also be followed by the suffix "K", "M", or "G" for kilobyte, megabyte, and gigabyte respectively. Default is "8G".
`-dos1540 <name>`
  Specify the ROM name for the 1540 emulation (`DosName1540`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1541 <name>`
  Specify the ROM name for the 1541 emulation (`DosName1541`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1541II <name>`
  Specify the ROM name for the 1541-II emulation (`DosName1541ii`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1551 <name>`
  Specify the ROM name for the 1551 emulation (`DosName1551`). (xplus4 only)
`-dos1570 <name>`
  Specify the ROM name for the 1570 emulation (`DosName1570`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1571 <name>`
  Specify the ROM name for the 1571 emulation (`DosName1571`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1571cr <name>`
  Specify the ROM name for the 1571 emulation (`DosName1571CR`). (x128 only)
`-dos1581 <name>`
  Specify the ROM name for the 1581 emulation (`DosName1581`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos2000 <name>`
  Specify the ROM name for the FD2000 emulation (`DosName2000`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos4000 <name>`
  Specify the ROM name for the FD4000 emulation (`DosName4000`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dosCMDHD <name>`
  Specify the boot ROM name for the CMD HD emulation (`DosNameCMDHD`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos2031 <name>`
  Specify the ROM name for the 2031 emulation (`DosName2031`). (all emulators except x64dtv, xplus4 and vsid)
`-dos2040 <name>`
  Specify the ROM name for the 2040 emulation (`DosName2040`). (all emulators except x64dtv, xplus4 and vsid)
`-dos3040 <name>`
  Specify the ROM name for the 3040 emulation (`DosName3040`). (all emulators except x64dtv, xplus4 and vsid)
`-dos4040 <name>`
  Specify the ROM name for the 4040 emulation (`DosName4040`). (all emulators except x64dtv, xplus4 and vsid)
`-dos1001 <name>`
  Specify the ROM name for the 1001, 8050 and 8250 emulations (`DosName1001`). (all emulators except x64dtv, xplus4 and vsid)
`-dos9000 <name>`
  Specify the ROM name for the D9090/60 emulations (`DosName9000`). (all emulators except x64dtv, xplus4 and vsid)
`-drive8ram2000, +drive8ram2000`
`-drive9ram2000, +drive9ram2000`
`-drive10ram2000, +drive10ram2000`
`-drive11ram2000, +drive11ram2000`
  Enable/disable 8KiB RAM expansion at $2000-$3FFF for drive 8 to 11 (`Drive8RAM2000=1`, `Drive8RAM2000=0`, `Drive9RAM2000=1`, `Drive9RAM2000=0`, `Drive10RAM2000=1`, `Drive10RAM2000=0`, `Drive11RAM2000=1`, `Drive11RAM2000=0`).
`-drive8ram4000, +drive8ram4000`
`-drive9ram4000, +drive9ram4000`
`-drive10ram4000, +drive10ram4000`
`-drive11ram4000, +drive11ram4000`
  Enable/disable 8KiB RAM expansion at $4000-$5FFF for drive 8 to 11 (`Drive8RAM4000=1`, `Drive8RAM4000=0`, `Drive9RAM4000=1`, `Drive9RAM4000=0`, `Drive10RAM4000=1`, `Drive10RAM4000=0`, `Drive11RAM4000=1`, `Drive11RAM4000=0`).
`-drive8ram6000, +drive8ram6000`
`-drive9ram6000, +drive9ram6000`
`-drive10ram6000, +drive10ram6000`
`-drive11ram6000, +drive11ram6000`
  Enable/disable 8KiB RAM expansion at $6000-$7FFF for drive 8 to 11 (`Drive8RAM6000=1`, `Drive8RAM6000=0`, `Drive9RAM6000=1`, `Drive9RAM6000=0`, `Drive10RAM6000=1`, `Drive10RAM6000=0`, `Drive11RAM6000=1`, `Drive11RAM6000=0`).
`-drive8ram8000, +drive8ram8000`
`-drive9ram8000, +drive9ram8000`
`-drive10ram8000, +drive10ram8000`
`-drive11ram8000, +drive11ram8000`
  Enable/disable 8KiB RAM expansion at $8000-$9FFF for drive 8 to 11 (`Drive8RAM8000=1`, `Drive8RAM8000=0`, `Drive9RAM8000=1`, `Drive9RAM8000=0`, `Drive10RAM8000=1`, `Drive10RAM8000=0`, `Drive11RAM8000=1`, `Drive11RAM8000=0`).
`-drive8rama000, +drive8rama000`
`-drive9rama000, +drive9rama000`
`-drive10rama000, +drive10rama000`
`-drive11rama000, +drive11rama000`
  Enable/disable 8KiB RAM expansion at $A000-$BFFF for drive 8 to 11 (`Drive8RAMA000=1`, `Drive8RAMA000=0`, `Drive9RAMA000=1`, `Drive9RAMA000=0`, `Drive10RAMA000=1`, `Drive10RAMA000=0`, `Drive11RAMA000=1`, `Drive11RAMA000=0`).
`-drive8profdos, +drive8profdos`
`-drive9profdos, +drive9profdos`
`-drive10profdos, +drive10profdos`
`-drive11profdos, +drive11profdos`
  Enable/disable Professional DOS for drive 8 to 11 (`Drive8ProfDOS=1`, `Drive8ProfDOS=0`, `Drive9ProfDOS=1`, `Drive9ProfDOS=0`, `Drive10ProfDOS=1`, `Drive10ProfDOS=0`, `Drive11ProfDOS=1`, `Drive11ProfDOS=0`) (x64, x64sc, xscpu64 and x128 only).
`-profdos1571 <name>`
  Specify name of Professional DOS 1571 ROM image (`DriveProfDOS1571Name`) (x64, x64sc, xscpu64 and x128).
`-drive8supercard, +drive8supercard`
`-drive9supercard, +drive9supercard`
`-drive10supercard, +drive10supercard`
`-drive11supercard, +drive11supercard`
  Enable/disable Supercard for drive 8 to 11 (`Drive8SuperCard=1`, `Drive8SuperCard=0`, `Drive9SuperCard=1`, `Drive9SuperCard=0`, `Drive10SuperCard=1`, `Drive10SuperCard=0`, `Drive11SuperCard=1`, `Drive11SuperCard=0`) (x64, x64sc, xscpu64 and x128 only).
`-supercard <name>`
  Specify name of Supercard ROM image (`DriveSuperCardName`) (x64, x64sc, xscpu64 and x128 only).
`-drive8stardos, +drive8stardos`
`-drive9stardos, +drive9stardos`
`-drive10stardos, +drive10stardos`
`-drive11stardos, +drive11stardos`
  Enable/disable StarDOS for drive 8 to 11 (`Drive8StarDos=1`, `Drive8StarDos=0`, `Drive9StarDos=1`, `Drive9StarDos=0`, `Drive10StarDos=1`, `Drive10StarDos=0`, `Drive11StarDos=1`, `Drive11StarDos=0`) (x64, x64sc, xscpu64 and x128 only).
`-stardos <name>`
  Specify name of the image of the lower half of the StarDOS ROM. (Attach the upper half using the -dos1541 option.) (`DriveStarDosName`) (x64, x64sc, xscpu64 and x128 only).
`-flipname <name>`
  Specify name of the flip list file image (Drive 8 only) (`FliplistName`) (all emulators except vsid).

## 6.12 Peripheral settings

VICE is able to support some special peripherals:

- file system devices, pseudo-drives accessing the Unix file system;
- printers.

These features depend on some kernal traps that replace the existing routines in the original Commodore operating system with custom-made C routines.

### 6.12.1 Settings for file system devices

These settings deal with the drive-like peripherals connected to the bus of the emulated machine. The first setting relates to the parallel IEEE488 interface. With this interface a special engine is used to listen to the bus lines to translates them to the filesystem code. Thus the PET will always detect a drive for example, but it can also use drives 10 and 11 even together with true disk drive emulation.

- "Enable virtual devices", enables the peripheral access via the fast disk emulation (either kernal traps or IEEE488 interface). Both, filesystem and disk image access via fast drive emulation, are affected.

Four peripherals, numbered from 8 to 11, are accessible; each of them provides the following settings:

- "File system access", if enabled, allows the device to emulate a drive accessing a file system directory; note that when a disk image is attached to the same drive, the directory is no longer visible and the attached disk is used instead.
- "File system directory" specifies the directory to be accessed by the drive.
- "Convert P00 file names", if enabled, allows access to P00 files using their built-in name instead of the Unix one.
- "Create P00 files on save", if enabled, creates P00 files (instead of raw CBM files) whenever a program creates a file.

Note that, by default, all drives create P00 files on save.

#### 6.12.1.1 Resources for file system devices

`IECDevice8`
`IECDevice9`
`IECDevice10`
`IECDevice11`
  Booleans that specify whether IEC device emulation for device #8 to #11 is enabled.
`FileSystemDevice8`
`FileSystemDevice9`
`FileSystemDevice10`
`FileSystemDevice11`
  Integers specifying the device type for device 8-11 respectively (all emulators except vsid). (0: None, 1: Filesystem, 2: OpenCBM (Real))
`FSDevice8ConvertP00`
`FSDevice9ConvertP00`
`FSDevice10ConvertP00`
`FSDevice11ConvertP00`
  Booleans specifying whether on-read support for P00 files is enabled on drives 8, 9, 10 and 11 respectively (all emulators except vsid).
`FSDevice8SaveP00`
`FSDevice9SaveP00`
`FSDevice10SaveP00`
`FSDevice11SaveP00`
  Booleans specifying whether the drives should create P00 files instead of plain CBM ones for drives 8, 9, 10 and 11 respectively (all emulators except vsid).
`FSDevice8HideCBMFiles`
`FSDevice9HideCBMFiles`
`FSDevice10HideCBMFiles`
`FSDevice11HideCBMFiles`
  Booleans specifying whether non-P00 files should be invisible for drives 8, 9, 10 and 11 respectively (all emulators except vsid).
`FSDevice8Dir`
`FSDevice9Dir`
`FSDevice10Dir`
`FSDevice11Dir`
  Strings specifying the directories to which drives 8, 9, 10 and 11 have access (all emulators except vsid).
`FSDeviceLongNames`
  Boolean specifying whether filenames will get converted to 16 character long short names or not. Disabled by default.
`FSDeviceOverwrite`
  Boolean specifying whether files in the file system can be overwritten without using `"@:name"`, or not. Disabled by default.

#### 6.12.1.2 Command-line options for file system devices

`-iecdevice8`
`+iecdevice8`
  Enable/disable IEC device emulation for device #8 (`IECDevice8=1`, `IECDevice8=0`).
`-iecdevice9`
`+iecdevice9`
  Enable/disable IEC device emulation for device #9 (`IECDevice9=1`, `IECDevice9=0`).
`-iecdevice10`
`+iecdevice10`
  Enable/disable IEC device emulation for device #10 (`IECDevice10=1`, `IECDevice10=0`).
`-iecdevice11`
`+iecdevice11`
  Enable/disable IEC device emulation for device #11 (`IECDevice11=1`, `IECDevice11=0`).
`-device8 <type>`
`-device9 <type>`
`-device10 <type>`
`-device11 <type>`
  Set device type for device 8-11 respectively (`FileSystemDevice8`, `FileSystemDevice9`, `FileSystemDevice10`, `FileSystemDevice11`) (all emulators except vsid). (0: None, 1: Filesystem, 2: OpenCBM (Real))
`-fs8 <Name>`
`-fs9 <Name>`
`-fs10 <Name>`
`-fs11 <Name>`
  Specify the paths for the file system access on drives 8, 9, 10 and 11, respectively (`FSDevice8Dir`, `FSDevice9Dir`, `FSDevice10Dir` and `FSDevice11Dir`) (all emulators except vsid).
`-fs8convertp00`
`+fs8convertp00`
  Enable/disable on-read support for P00 files on drive 8 (`FSDevice8ConvertP00=1`, `FSDevice8ConvertP00=0`) (all emulators except vsid).
`-fs9convertp00`
`+fs9convertp00`
  Enable/disable on-read support for P00 files on drive 9 (`FSDevice9ConvertP00=1`, `FSDevice9ConvertP00=0`) (all emulators except vsid).
`-fs10convertp00`
`+fs10convertp00`
  Enable/disable on-read support for P00 files on drive 10 (`FSDevice10ConvertP00=1`, `FSDevice10ConvertP00=0`) (all emulators except vsid).
`-fs11convertp00`
`+fs11convertp00`
  Enable/disable on-read support for P00 files on drive 11 (`FSDevice11ConvertP00=1`, `FSDevice11ConvertP00=0`) (all emulators except vsid).
`-fs8savep00`
`+fs8savep00`
  Enable/disable saving P00 files on drive 8 (`FSDevice8SaveP00=1`, `FSDevice8SaveP00=0`) (all emulators except vsid).
`-fs9savep00`
`+fs9savep00`
  Enable/disable saving P00 files on drive 9 (`FSDevice9SaveP00=1`, `FSDevice9SaveP00=0`) (all emulators except vsid).
`-fs10savep00`
`+fs10savep00`
  Enable/disable saving P00 files on drive 10 (`FSDevice10SaveP00=1`, `FSDevice10SaveP00=0`) (all emulators except vsid).
`-fs11savep00`
`+fs11savep00`
  Enable/disable saving P00 files on drive 11 (`FSDevice11SaveP00=1`, `FSDevice11SaveP00=0`) (all emulators except vsid).
`-fs8hidecbm`
`+fs8hidecbm`
  Enable/disable hiding of CBM files for drive 8 (`FSDevice8HideCBMFiles=1`, `FSDevice8HideCBMFiles=0`) (all emulators except vsid).
`-fs9hidecbm`
`+fs9hidecbm`
  Enable/disable hiding of CBM files for drive 9 (`FSDevice9HideCBMFiles=1`, `FSDevice9HideCBMFiles=0`) (all emulators except vsid).
`-fs10hidecbm`
`+fs10hidecbm`
  Enable/disable hiding of CBM files for drive 10 (`FSDevice10HideCBMFiles=1`, `FSDevice10HideCBMFiles=0`) (all emulators except vsid).
`-fs11hidecbm`
`+fs11hidecbm`
  Enable/disable hiding of CBM files for drive 11 (`FSDevice11HideCBMFiles=1`, `FSDevice11HideCBMFiles=0`) (all emulators except vsid).
`-fslongnames`
`+fslongnames`
  Enable/disable whether filenames will get converted to 16 character long short names (`FSDeviceLongNames=1`, `FSDeviceLongNames=0`) (all emulators except vsid).
`-fsoverwrite`
`+fsoverwrite`
  Enable/disable whether existing files in the file system can be overwritten by default. Using `OPEN` or `SAVE"@:name"` this is always possible. (`FSDeviceOverwrite=1`, `FSDeviceOverwrite=0`) (all emulators except vsid).

### 6.12.2 Printer settings

The VICE emulators can emulate printers connected to either the IEC buffer or the user port. Emulation can be achieved by redirecting the printer output to a file or by piping it through an external process. This is defined by so-called printer device file names; a printer device file name can be either a simple path, or a command name preceeded by a pipe symbol ``|'`.

For example, printer device ``filename'` will cause the output to be appended to the file ``filename'`, while printer device ``|lpr'` will cause the `lpr` command to be executed and be fed the printer output. The printer output will not be converted but saved as printed by the emulated machine.

Up to three printer devices may be specified through the following resources:

- device 1, whose default value is `print.dump`;
- device 2, whose default value is `|lpr`.
- device 3, whose default value is `|petlp -F PS|lpr`;

So, basically, by default printer device 1 will dump printer output to ``print.dump'`; printer device 2 will print it via `lpr` directly to the printer and device 3 will print it via `petlp` (a not-yet-complete utility that will produce Postscript output from the Commodore printer code) and then to the printer via `lpr`.

#### 6.12.2.1 Printer resources

`IECDevice4`
`IECDevice5`
`IECDevice6`
`IECDevice7`
  Booleans that specify whether IEC device emulation for device #4, #5, #6 and #7 is enabled.
`PrinterTextDevice1`
`PrinterTextDevice2`
`PrinterTextDevice3`
  Strings specifying the printer devices (see section 6.12.2 Printer settings).
`Printer4TextDevice`
`Printer5TextDevice`
`Printer6TextDevice`
  Integer (ranging from 0 to 2, for device 1-3) specifying what printer device (see section 6.12.2 Printer settings) the IEC printer is using.
`Printer4`
`Printer5`
`Printer6`
  Integer specifying how the printer (device 4-6) is being emulated. (0: None, 1: Filesystem, 2: Real)
`Printer7`
  Integer specifying how printer 7 is being emulated. (0: None, 2: Real)
`Printer4Driver`
  String specifying the printer output driver. (raw, ascii, 2022, 4023, 8023, mps801, mps802, mps803, nl10)
`Printer5Driver`
  String specifying the printer output driver. (raw, ascii, 2022, 4023, 8023, mps801, mps802, mps803, nl10)
`Printer6Driver`
  String specifying the printer output driver. (raw, 1520)
`Printer4Output`
`Printer5Output`
`Printer6Output`
  Strings specifying the IEC printer output device. (text, graphics)
`PrinterUserportTextDevice`
  Integer (ranging from 0 to 2, for device 1-3) specifying what printer device the user-port printer is using.
`PrinterUserportDriver`
  String specifying the user-port printer output driver. (ascii/nl10/raw)
`PrinterUserportOutput`
  String specifying the user-port printer output device. (text, graphics)

#### 6.12.2.2 Printer command-line options

`-iecdevice4`
`+iecdevice4`
  Enable/disable IEC device emulation for device #4 (`IECDevice4=1`, `IECDevice4=0`).
`-iecdevice5`
`+iecdevice5`
  Enable/disable IEC device emulation for device #5 (`IECDevice5=1`, `IECDevice5=0`).
`-iecdevice6`
`+iecdevice6`
  Enable/disable IEC device emulation for device #6 (`IECDevice6=1`, `IECDevice6=0`).
`-iecdevice7`
`+iecdevice7`
  Enable/disable IEC device emulation for device #7 (`IECDevice7=1`, `IECDevice7=0`).
`-device4 <type>`
  Set device type for device 4 (`Printer4`). (0: None, 1: Filesystem, 2: Real)
`-device5 <type>`
  Set device type for device 5 (`Printer5`). (0: None, 1: Filesystem, 2: Real)
`-device6 <type>`
  Set device type for device 6 (`Printer6`). (0: None, 1: Filesystem, 2: Real)
`-device7 <type>`
  Set device type for device 7 (`Printer7`). (0: None, 2: Real)
`-prtxtdev1 <name>`
`-prtxtdev2 <name>`
`-prtxtdev3 <name>`
  Specify name of printer text device or dump file (`PrinterTextDevice1`, `PrinterTextDevice2`, `PrinterTextDevice3`).
`-pr4txtdev <0-2>`
`-pr5txtdev <0-2>`
`-pr6txtdev <0-2>`
  Specify printer text output device for IEC printer #4-6 (`Printer4TextDevice`, `Printer5TextDevice`, `Printer6TextDevice`).
`-pr4output <name>`
  Specify name of output device for device #4 (`Printer4Output`). (text, graphics)
`-pr5output <name>`
  Specify name of output device for device #5 (`Printer5Output`). (text, graphics)
`-pr6output <name>`
  Specify name of output device for device #6 (`Printer6Output`). (text, graphics)
`-pr4drv <name>`
  Specify name of printer driver for device #4 (`Printer4Driver`). (raw, ascii, 2022, 4023, 8023, mps801, mps802, mps803, nl10)
`-pr5drv <name>`
  Specify name of printer driver for device #5 (`Printer5Driver`). (raw, ascii, 2022, 4023, 8023, mps801, mps802, mps803, nl10)
`-pr6drv <name>`
  Specify name of printer driver for device #6 (`Printer6Driver`). (raw, 1520)
`-prusertxtdev <0-2>`
  Specify printer text output device for userport printer (`PrinterUserportTextDevice`).
`-pruseroutput <name>`
  Specify name of output device for the userport printer (`PrinterUserportOutput`). (text, graphics)
`-pruserdrv <name>`
  Specify name of printer driver for the userport printer (`PrinterUserportDriver`).

### 6.12.3 Disabling kernal traps

If you have compatibility problems, you can completely disable Kernal traps with the "Disable kernal traps" option. This will of course disable all the features that depend on it, such as the fast 1541 emulation (so you will have to turn true 1541 emulation on if you want to be able to read or write disk images) and tape (t64) support.

Since the 3.0 release kernal traps have been disabled by default to ensure maximum compatibility.

#### 6.12.3.1 Resources to control Kernal traps

`VirtualDevice1`
`VirtualDevice2`
`VirtualDevice4`
`VirtualDevice5`
`VirtualDevice6`
`VirtualDevice7`
`VirtualDevice8`
`VirtualDevice9`
`VirtualDevice10`
`VirtualDevice11`
  Boolean specifying whether all the mechanisms for virtual device emulation should be enabled. Serial IEC devices use kernal traps, parallel IEEE488 devices use an own IEEE488 engine. Both are switched on and off with this resource.

#### 6.12.3.2 Command-line options to control Kernal traps

`-virtualdev1, +virtualdev1`
`-virtualdev2, +virtualdev2`
`-virtualdev4, +virtualdev4`
`-virtualdev5, +virtualdev5`
`-virtualdev6, +virtualdev6`
`-virtualdev7, +virtualdev7`
`-virtualdev8, +virtualdev8`
`-virtualdev9, +virtualdev9`
`-virtualdev10, +virtualdev10`
`-virtualdev11, +virtualdev11`
  Enable/disable virtual devices (`VirtualDevice1=1`, `VirtualDevice1=0`, `VirtualDevice2=1`, `VirtualDevice2=0`, `VirtualDevice4=1`, `VirtualDevice4=0`, `VirtualDevice5=1`, `VirtualDevice5=0`, `VirtualDevice6=1`, `VirtualDevice6=0`, `VirtualDevice7=1`, `VirtualDevice7=0`, `VirtualDevice8=1`, `VirtualDevice8=0`, `VirtualDevice9=1`, `VirtualDevice9=0`, `VirtualDevice10=1`, `VirtualDevice10=0`, `VirtualDevice11=1`, `VirtualDevice11=0`).

## 6.13 RS232 settings

The VICE emulators can emulate the RS232 device most of the machines have. The C64, C128 and VIC20 emulators emulate the userport RS232 interface from 300 to 57600 baud. The C64 can also use the UP9600 interface by Daniel Dallmann, using the shift registers of the two CIA 6526 chips. The PET can have a 6551 ACIA RS232 interface when running as a SuperPET, and the CBM-II has such an ACIA by default. The C64 and C128 emulators can emulate an ACIA 6551 (also known as Swiftlink, Datapump or Turbo232 for example) as extension at `$de**`, `$df**` or `$d7**` (C128 only).

Emulation can be achieved by either:

- connecting a real serial device/port;
- dumping to a file;
- piping through a process.
- connect through a network socket.

It is possible to define up to four serial devices, and then decide which interface should be connected to which device. This is done by so-called rs232 device file names; an rs232 device file name can be either a simple path, a network address, or a command name preceeded by a pipe symbol ``|'`. If the path specifies a special device (e.g. ``/dev/ttyS0'` or ``com1'`) it is recognized by VICE and the emulator can set the baudrate.

For example, rs232 device ``filename'` will cause the output to be written (not appended) to the file ``filename'`, while printer device ``|lpr'` will cause the `lpr` command to be executed and be fed the rs232 output. The rs232 output will not be converted but saved as sent by the emulated machine. The same holds true for the rs232 input. If the command writes data to the standard output it will be caught by VICE and sent back to the emulator. Also the data sent by the pseudo device will be sent back to VICE.

For example you can setup a null-modem cable between two serial ports of your PC, setup one port for login and use the other in VICE. Then you can login from your emulator via the RS232 emulation and the null-modem cable to your machine again.

Up to four RS232 devices may be specified through the following resources:

- device 1, whose default value is `/dev/ttyS0`;
- device 2, whose default value is `/dev/ttyS1`;
- device 3, whose default value is `127.0.0.1:25232`;
- device 4, whose default value is `|nc 127.0.0.1:25232`.

(Only) when using physical RS232 ports, you'll also have to specify it on the commandline or in the menu.

### 6.13.1 RS232 resources

`RsDevice1`
`RsDevice2`
`RsDevice3`
`RsDevice4`
  Strings specifying the RS232 devices (see section 6.13 RS232 settings). The windows driver understands various options passed in the so called "mode string" after a colon after the ports name: `COMx[:]` `[baud=b]` `[parity=p]` `[data=d]` `[stop=s]` `[to={on|off`]} `[xon={on|off`]} `[odsr={on|off`]} `[octs={on|off`]} `[dtr={on|off|hs`]} `[rts={on|off|hs|tg`]} `[idsr={on|off`]}

`RsDevice1ip232`
`RsDevice2ip232`
`RsDevice3ip232`
`RsDevice4ip232`
  Boolean specifying whether the respective RS232 devices (see section 6.13 RS232 settings) use the IP232 protocol supported by tcpser. This only works with Socket connections.

`Acia1Enable`
  Boolean specifying whether the ACIA (Swiftlink, Turbo232) cartridge should be emulated or not (x64, x64sc, xscpu64, x128 and xvic only, and only if RS232 support is enabled and supported at compile time).
`Acia1Dev`
  Integer specifying what RS232 device (see section 6.13 RS232 settings) the ACIA is using (all emulators except x64dtv and vsid, and only if RS232 support is enabled and supported at compile time).
`Acia1Base`
  Integer specifying the base address for the emulated ACIA chip (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (xvic: $9800/$9C00, x128: $D700/$DE00/$DF00, x64, x64sc, xscpu64: $DE00/$DF00)
`Acia1Mode`
  Integer specifying the type of emulated RS232 interface (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0: normal, 1: Swiftlink, 2: Turbo232)
`Acia1Irq`
  Integer specifying which interrupt to use (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0 = none, 1 = NMI, 2 = IRQ)

`RsUserUP9600`
  Boolean specifying if the user-port RS232 interface is of the UP9600 type. (C64 only).
`RsUserRTSInv`
  Boolean specifying if the user-port RS232 Request to Send (RTS) flow control line is inverted. (C64, C128 and VIC20).
`RsUserCTSInv`
  Boolean specifying if the user-port RS232 Clear to Send (CTS) flow control line is inverted. (C64, C128 and VIC20).
`RsUserDSRInv`
  Boolean specifying if the user-port RS232 Data Set Ready (DSR) control line is inverted. (C64, C128 and VIC20).
`RsUserDCDInv`
  Boolean specifying if the user-port RS232 Data Carrier Detect (DCD) control line is inverted. (C64, C128 and VIC20).
`RsUserDTRInv`
  Boolean specifying if the user-port RS232 Data Terminal Ready (DTR) control line is inverted. (C64, C128 and VIC20).
`RsUserRIInv`
  Boolean specifying if the user-port RS232 Ring Indicator (RI) control line is inverted. (C64, C128 and VIC20).
`RsUserBaud`
  Integer specifying the baudrate of the user-port RS232 interface (C64, C128 and VIC20). This must match the baudrate the emulated user port is being used with, and needs to be set up by the user because automatically detecting it can not be done easily (like when using ACIA)
`RsUserDev`
  Integer (ranging from 0 to 3, for device 1-4) specifying what RS232 device the user-port interface is using (C64, C128 and VIC20).

The following resources are only available if RS232 device support or RS232 network support is available at compile time.

`RsDevice1Baud`
`RsDevice2Baud`
`RsDevice3Baud`
`RsDevice4Baud`
  Integers specifying the RS232 baudrate devices if the device file points to a special device (like ``/dev/ttyS0'` or ``com1'`, ie the serial device is a physical RS232 port of the host computer; see section 6.13 RS232 settings) (all emulators except vsid).

### 6.13.2 RS232 command-line options

`-rsdev1 <Name>`
`-rsdev2 <Name>`
`-rsdev3 <Name>`
`-rsdev4 <Name>`
  Specify <Name> as RS232 devices 1, 2, 3 and 4, respectively (`RsDevice1`, `RsDevice2` `RsDevice3` and `RsDevice4`). The windows driver understands various options passed in the so called "mode string" after a colon after the ports name: `COMx[:]` `[baud=b]` `[parity=p]` `[data=d]` `[stop=s]` `[to={on|off`]} `[xon={on|off`]} `[odsr={on|off`]} `[octs={on|off`]} `[dtr={on|off|hs`]} `[rts={on|off|hs|tg`]} `[idsr={on|off`]}

`-rsdev1ip232`
`+rsdev1ip232`
`-rsdev2ip232`
`+rsdev2ip232`
`-rsdev3ip232`
`+rsdev3ip232`
`-rsdev4ip232`
`+rsdev4ip232`
  Enable/Disable whether the respective RS232 devices (see section 6.13 RS232 settings) use the IP232 protocol supported by tcpser. This only works with Socket connections.

`-acia1`
`+acia1`
  Enable/Disable the $DE** ACIA RS232 interface emulation (`Acia1Enable=1`, `Acia1Enable=0`) (x64, x64sc, xscpu64, x128 and xvic only, and only if RS232 support is enabled and supported at compile time).
`-myaciadev <0-3>`
  Specify RS232 device the ACIA should work on (all emulators except x64dtv and vsid, and only if RS232 support is enabled and supported at compile time)
`-acia1base <Base address>`
  Set the base address of the ACIA cartridge (`Acia1Base`) (x64, x64sc, xscpu, x128 and xvic only, and only if RS232 support is enabled and supported at compile time). (xvic: $9800/$9C00, x128: $D700/$DE00/$DF00, x64, x64sc, xscpu: $DE00/$DF00)
`-acia1mode <mode>`
  Set the ACIA mode (`Acia1Mode`) (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0: Normal, 1: Swiftlink, 2: Turbo232)
`-acia1irq <interrupt>`
  Set the ACIA interrupt (`Acia1Irq`) (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0: None, 1: NMI, 2: IRQ)

`-rsuserup9600`
`+rsuserup9600`
  Enable or disable the userport RS232 UP9600 emulation (`RsUserUP9600`; C64 only)
`-rsuserrtsinv`
`+rsuserrtsinv`
  Enable or disable inversion of the userport RS232 emulation Request To Send (RTS) flow control line.
`-rsuserctsinv`
`+rsuserctsinv`
  Enable or disable inversion of the userport RS232 emulation Clear To Send (CTS) flow control line.
`-rsuserdsrinv`
`+rsuserdsrinv`
  Enable or disable inversion of the userport RS232 emulation Data Set Ready (DSR) control line.
`-rsuserdcdinv`
`+rsuserdcdinv`
  Enable or disable inversion of the userport RS232 emulation Data Carrier Detect (DCD) control line.
`-rsuserdtrinv`
`+rsuserdtrinv`
  Enable or disable inversion of the userport RS232 emulation Data Terminal Ready (DTR) control line.
`-rsuserriinv`
`+rsuserriinv`
  Enable or disable inversion of the userport RS232 emulation Ring Indicator (RI) control line.
`-rsuserbaud <baud>`
  Set the baud rate of the RS232 userport emulation. This must match the baudrate the emulated userport is being used at.
`-rsuserdev <0-3>`
  Specify device for the userport RS232 emulation (`RsUserDev`; C64, C128 and VIC20).

The following command-line options are only available if RS232 device support or RS232 network support is available at compile time.

`-rsdev1baud <baudrate>`
`-rsdev2baud <baudrate>`
`-rsdev3baud <baudrate>`
`-rsdev4baud <baudrate>`
  If the serial device is a physical RS232 port, specify <baudrate> as baudrate, see section 6.13 RS232 settings; `RsDevice1Baud`, `RsDevice2Baud` `RsDevice3Baud` and `RsDevice4Baud`) (all emulators except vsid).

### 6.13.3 RS232 usage example

Here we give you a simple example how to set up an emulated C64 using the modem connected to your PC. The following list shows each step.

`Attach your modem to your PC at a serial port.`
  Normally you should set it up to use the modem as "/dev/modem".
`start VICE`
`Setup VICE to use your modem as "serial device 1"`
  Go to the RS232 settings menu and change "Serial 1 device" to "/dev/modem" (or the device where you attached your modem to) Then go to the RS232 settings menu and change "Serial 1 baudrate" to the baudrate your modem should run at. Watch out, e.g. on Linux there is an additional multiplier to multiply with the baudrate (so e.g. 19200 gives 115200 or so baud) See the "setserial" manpage on Linux for example. However, most modems should be able to autodetect the speed to the computer as well.
`Select the RS232 emulation your programs use`
  If you want to use the Userport emulation, go to the RS232 settings and change "Userport RS232 Device" to "Serial 1". If you want ACIA emulation (swiftlink or what's it called?) then change "ACIA $DE** device" to "Serial 1".
`Enable the emulation`
  Go to the RS232 settings and select either "ACIA $DE** emulation" or Userport 300/1200 baud or CIA 9600 baud emulation.
`Load your program and start it.`
  If it is able to detect an RS232 cartridge like swiftlink or so, try to detect the ACIA emulation if enabled. Otherwise just set the baudrate to either 300, 1200, 2400 or 9600 according to what you enabled in the VICE menu for the userport.

## 6.14 Ethernet emulation

To use the ethernet emulation features, VICE must be configured with --enable-ethernet before compiling, and the system headers for libpcap, libnet and/or tuntap must be present.

In Windows you will have to install the npcap driver, which is available from https://npcap.com/#download (select winpcap compatibility mode when installing).

It should be clear to you that it may pose a security problem using these libraries in a network. Using libpcap can result in disclosure of any information that is available on your network which is not secured by other means! Furthermore, libnet might allow even further attacks on your infrastructure!

Installing libpcap and libnet, you acknowledge that you're well aware of these security problems and that the VICE team cannot be made responsible for any problems and/or damage which may arise from the use of these libraries! If you don't acknowledge this, don't install the tools and/or use VICE networking.

### 6.14.1 Ethernet usage example

- Go to Preferences -> Peripherial Devices -> Ethernet and select the driver and network interface you want to use. If this option is not present at all, then VICE was compiled without ethernet support or the respective libraries could not be found on your system (see note above). If the option exists but is not enabled, you may not have the required permissions to use the raw ethernet device - you can try to run VICE as root/Administrator (the usual precautions apply), on *nix platforms VICE also supports the "capabilities" mechanism.
- Go to Preferences -> Cartridges - Ethernet Cartridge and select "Enable ethernet cartridge". Most likely you want to enable "RR-Net compatibility mode", too. (If this option is not set, the ethernet emulation runs in "The Final Ethernet" mode). The cartridge I/O base should be at its default value of $de00.
- Run the RR-Net enabled C64 program.
- If the program can not access the network, check your router setup. The raw ethernet emulation works exactly like a "real" ethernet device in the network, eg the emulated ethernet device gets its own MAC adress, which you may have to allow to access the internet at your router.

### 6.14.2 Ethernet resources

The following are the generic ethernet resources, some more may exist for the individual emulators:

`ETHERNET_INTERFACE`
  String specifying the device name of the ethernet device to use for the emulation.
`ETHERNET_DRIVER`
  String specifying the low-level ethernet driver for Ethernet Cartridge emulation (tuntap, pcap).
`ETHERNET_DISABLED`
  Boolean that specified whether ethernet emulation has been disabled because it is not available in the current configuration.

### 6.14.3 Ethernet command line options

`-ethernetioif <name>`
  Set the system ethernet interface for Ethernet Cartridge emulation (`ETHERNET_INTERFACE`).
`-ethernetiodriver <name>`
  Set the low-level ethernet driver for Ethernet Cartridge emulation (`ETHERNET_DRIVER`). (tuntap, pcap)

## 6.15 Tape port devices

### 6.15.1 Tape port resources

`TapePort1Device`
  Set the device attached to the (first) tape port (see table below):
`TapePort2Device`
  Set the device attached to the second tape port (xpet only, see table below):

0 | None | x64, x64sc, x128, xvic, xplus4, xpet, xcbm2
1 | Datasette | x64, x64sc, x128, xvic, xplus4, xpet, xcbm2
2 | Tape RTC (PCF8583) | x64, x64sc, x128, xvic, xplus4, xpet, xcbm2
3 | DTL BASIC dongle | x64, x64sc, x128
4 | Sense dongle | x64, x64sc, x128, xvic, xplus4, xpet, xcbm2
6 | tapecart | x64, x64sc, x128

`CPClockF83Save`
  Boolean specifying whether the CP Clock F83 (PCF8583 RTC) data is saved when changed.
`TapecartUpdateTCRT`
  Boolean, if true write back the tapecart memory contents back to the .tcrt file when detaching the image or quitting the emulator.
`TapecartOptimizeTCRT`
  Boolean, when set to true the .tcrt image will be optimized by leaving out blank space at the end when saving.
`TapecartLogLevel`
  Integer that specifies the tapecart emulation log level. At the default level of 0, only errors are logged. Level 1 additionally logs mode changes and command bytes and level 2 adds details of command parameters.
`TapecartTCRTFilename`
  String specifying the file name of the current tapecart image.

### 6.15.2 Tape port command line options

`-tapeport1device <device>`
  Set the device attached to the (first) tape port: (see table for `TapePort1Device` above).
`-tapeport2device <device>`
  Set the device attached to the second tape port: (see table for `TapePort2Device` above).
`-cpclockf83save`
`+cpclockf83save`
  Enable/Disable saving of the CP Clock F83 (PCF8583 RTC) data when changed (`CPClockF83Save=1`, `CPClockF83Save=0`).
`-tcrt <name>`
  Specify tapecart .tcrt image filename (`TapecartTCRTFilename`)
`-tapecartupdatetcrt`
`+tapecartupdatetcrt`
  Specify if the attached .tcrt image should be updated when the emulated tapecart is written to. (`TapecartUpdateTCRT=1`, `TapecartUpdateTCRT=0`)
`-tapecartoptimizetcrt`
`+tapecartoptimizetcrt`
  Specify if writing to a .tcrt file should optimize its size by leaving out blank space at the end. (`TapecartOptimizeTCRT=1`, `TapecartOptimizeTCRT=0`)
`-tapecartloglevel <number>`
  Specify the tapecart log level. The default level of 0 only logs errors. Level 1 additionally logs mode changes and command bytes and level 2 adds details of command parameters.

## 6.16 Userport devices

### 6.16.1 Userport resources

`UserportDevice`
  Set the device attached to the userport (see table below):

0 | None | x64, x64sc, x128, xscpu64, x64dtv, xvic, xplus4, xpet, xcbm2
1 | Userport printer | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
2 | Userport RS232/Modem | x64, x64sc, x128, xscpu64, xvic
3 | CGA userport joy adapter | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
4 | PET userport joy adapter | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
5 | Hummer userport joy adapter | x64dtv
6 | OEM userport joy adapter | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
7 | HIT userport joy adapter | x64, x64sc, x128, xscpu64
8 | KingSoft userport joy adapter | x64, x64sc, x128, xscpu64
9 | StarByte userport joy adapter | x64, x64sc, x128, xscpu64
10 | Synergy userport joy adapter | xplus4
11 | Wheel of joystick 8-joy userport joy adapter | x64, x64sc, x128, xscpu64, xvic, xplus4, xpet, xcbm2
12 | Userport DAC | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
13 | Userport DigiMAX | x64, x64sc, x128, xscpu64, xcbm2
14 | Userport 4bit sampler | x64, x64sc, x128, xscpu64, xcbm2
15 | Userport 8bit stereo sampler | x64, x64sc, x128, xscpu64, xcbm2
16 | Userport RTC (RTC58321A) | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
17 | Userport RTC (DS1307) | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
18 | Userport Petscii SNES pad | x64, x64sc, x128, xscpu64, xvic, xpet, xcbm2
19 | Userport SuperPad64 | x64, x64sc, x128, xscpu64, xcbm2
20 | Userport Diag 586220 Harness | x64, x64sc, x128, xscpu64
21 | Userport parallel drive cable | x64, x64sc, x128, xscpu64, xplus4
22 | Userport I/O Simulation | x64, x64sc, x128, xscpu64, x64dtv, xvic, xplus4, xpet, xcbm2
23 | Userport WiC64 Simulation | x64, x64sc, x128, xscpu64, xvic
24 | Joystick Adapter (Spaceballs) | x64, x64sc, x128, xscpu64, xvic
25 | Userport Stupid Pet Tricks joystick adapter | x64, x64sc, x128, xscpu64, xcbm2, xpet, xvic
26 | PET Userport diagnostic pin | xpet

`UserportRTC58321aSave`
  Boolean specifying whether the userport RTC data is saved when changed or not (xpet, cbm2, x64, x64sc, xscpu64 and x128 only).
`UserportRTCDS1307Save`
  Boolean specifying whether the userport RTC data is saved when changed or not (xpet, cbm2, x64, x64sc, xscpu64 and x128 only).
`WIC64DefaultServer`
  String specifying the default server URL used by the wic64 emulation (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64Timezone`
  Integer specifying the default timezone used by the wic64 emulation (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64SecToken`
  String specifying the security token used by the wic64 emulation for identifying the user at the WiC64 portal. (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64MACAddress`
  String specifying the pseudo MAC address used by the wic64 emulation for identifying the user at the WiC64 portal (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64IPAddress`
  String specifying the IP address used by the wic64 emulation (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64Logenabled`
  Integer, 1: user selected WiC64 tracing, 0: no tracing (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64Resetuser`
  Integer, 1: user credentials shall be reseted if WiC64 is reseted, 0: user credentials are preseved (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64HexdumpLines`
  Integer number of lines to hexdump, 0: unlimited (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64RemoteTimeout`
  Integer, 1-255: Timeout to wait for URLs in seconds (vic20, x64, x64sc, xscpu64 and x128 only).
`WIC64LogLevel`
  Integer, WiC64 trace level, 0: no trace, 1: standard, 2: verbose, 3: debug (vic20, x64, x64sc, xscpu64 and x128 only).

### 6.16.2 Userport command line options

`-userportdevice <device>`
  Set the device attached to the userport (see table for `UserportDevice` above).
`-userportrtc58321asave`
`+userportrtc58321asave`
  Disable/enable saving of the userport RTC data when changed (`UserportRTC58321aSave=1`, `UserportRTC58321aSave=0`) (xpet, cbm2, x64, x64sc, xscpu64 and x128 only).
`-userportrtcds1307save`
`+userportrtcds1307save`
  Disable/enable saving of the userport RTC data when changed (`UserportRTCDS1307Save=1`, `UserportRTCDS1307Save=0`) (xpet, cbm2, x64, x64sc, xscpu64 and x128 only).
`-wic64server <URL>`
  String specifying the default server URL used by the wic64 emulation, (vic20, x64, x64sc, xscpu64 and x128 only).
`-wic64timezone <0..31>`
  Integer to specify default timezone index, e.g. 2: European Central Time", (vic20, x64, x64sc, xscpu64 and x128 only).
`-wic64reset`
  Resets wic64 related resources to factory defaults (including user credentials) (vic20, x64, x64sc, xscpu64 and x128 only).
`-wic64trace`
`+wic64trace`
  Enable/disable WIC64 tracing on the console (vic20, x64, x64sc, xscpu64 and x128 only).
`-wic64tracelevel <0..3>`
  Integer to specify WIC64 trace level (0: off, 1: commands, >2: debug), implicitly turns on/off WiC64 tracing. (vic20, x64, x64sc, xscpu64 and x128 only).
`-wic64hexdumplines <value>`
  Integer to specify number of lines to hexdump, 0: unlimited, (vic20, x64, x64sc, xscpu64 and x128 only).
`-wic64remotetimeout <value>`
  Timeout to wait for URLs in seconds, 1 - 255 (vic20, x64, x64sc, xscpu64 and x128 only).

## 6.17 Monitor settings

This section lists command-line options specific to the built-in monitor.

### 6.17.1 Monitor resources

`KeepMonitorOpen`
  Boolean, if true the monitor window may stay open when the emulation is running, eg to look at trace-point output. (Not all ports/UIs support this, in that case this setting has no effect.)
`RefreshOnBreak`
  Boolean, if true, the emulated display(s) will update as the monitor is entered and also after each command executed via the monitor. Not entirely accurate yet, as updates become visible one scanline at a time. In addtion, the image can be not quite right around the raster line being updated.
`MonitorServer`
  Boolean specifying whether the remote monitor server is enabled.
`MonitorServerAddress`
  String specifying the address the remote monitor server listens to (ip4://127.0.0.1:6510)
`BinaryMonitorServer`
  Boolean specifying whether the binary monitor server is enabled.
`BinaryMonitorServerAddress`
  String specifying the address the binary monitor server listens to (ip4://127.0.0.1:6502)
`NativeMonitor`
  Boolean specifying whether the native monitor is enabled. When enabled, the monitor will not run in the interface of the emulator, but instead work in the spawning terminal.
`MonitorLogEnabled`
  Boolean specifying whether the output of the monitor will be logged to a file.
`MonitorLogFileName`
  String specifying the logfile name for the monitor.
`MonitorChisLines`
  Integer specifying the number of lines to keep in the cpu history. (only when enabled in configure)
`MonitorScrollbackLines`
  Integer specifying the number of lines to keep in the monitor scrollback buffer (-1 for no limit).
`MonitorFont`
  String specifying the font to use in the Gtk3 UI's VTE monitor window. Should be in the form accepted by Pango, for example "Liberation Mono 11".
`MonitorFG`
  String specifying the foreground color to use in the Gtk3 UI's VTE monitor window. Should be in form accepted by Pango: either a CSS color name (for example 'limegreen'), three/six digit hex string ("#rgb"/"#rrggbb") or three decimal values in the range 0-255 ("rbg(red,green,blue"), for example "rgb(27,180,33)").
`MonitorBG`
  String specifying the background color to use in the Gtk3 UI's VTE monitor window. Should be in form accepted by Pango: either a CSS color name (for example 'limegreen'), three/six digit hex string ("#rgb"/"#rrggbb") or three decimal values in the range 0-255 ("rbg(red,green,blue"), for example "rgb(27,180,33)").
`MonitorXPos`
  Integer specifying the Gtk3 VTE-monitor window's X position.
`MonitorYPos`
  Integer specifying the Gtk3 VTE-monitor window's Y position.
`MonitorWidth`
  Integer specifying the Gtk3 VTE-monitor window's width.
`MonitorHeight`
  Integer specifying the Gtk3 VTE-monitor window's height.

### 6.17.2 Monitor command-line options

`-moncommands <Name>`
  Execute the commands from the file <Name> in the monitor after starting up. All monitor commands are supported, including playback of other command files via `pb`. By default, the monitor opens and starts executing the commands just before the kernal reset routine starts. The kernal startup sequence may interfere with what you are trying to achieve, for example by clearing any basic listing you may have loaded. In this case, use the `-initbreak` option to control when the monitor will open and execute your script. You can choose an address, or use `-initbreak ready` to attempt to detect when the kernel is ready and execute the script then.
`-initbreak <address>`
`-initbreak reset`
`-initbreak ready`
  Set an initial breakpoint for the monitor. Addresses with prefix "0x" are hexadecimal. `-initbreak reset` will break just before the reset routine starts. `-initbreak ready` will attempt to break when the kernal is 'ready'.
`-keepmonopen`
`+keepmonopen`
  Enable/disable keeping the monitor window open (`KeepMonitorOpen=1`, `KeepMonitorOpen=0`).
`-refreshonbreak`
`+refreshonbreak`
  Enable/Disable refresh display when entering monitor and after each monitor command. (`RefreshOnBreak=1`, `RefreshOnBreak=0`).
`-remotemonitor`
`+remotemonitor`
  Enable/Disable remote monitor
`-remotemonitoraddress <name>`
  The local address the remote monitor should bind to
`-binarymonitor`
`+binarymonitor`
  Enable/Disable binary monitor
`-binarymonitoraddress <name>`
  The local address the binary monitor should bind to
`-nativemonitor`
`+nativemonitor`
  Enable/Disable native monitor. (`NativeMonitor=1`, `NativeMonitor=0`).
`-monlog`
`+monlog`
  Enable/Disable logging monitor output to a file. (`MonitorLogEnabled=1`, `MonitorLogEnabled=0`).
`-monlogname <name>`
  Specify logfile name for the monitor. (`MonitorLogFileName`).
`-monchislines <value>`
  Set number of lines to keep in the cpu history. (only when enabled in configure) (`MonitorChisLines`).
`-monscrollbacklines <value>`
  Set number of lines to keep in the monitor scrollback buffer (-1 for no limit). (`MonitorScrollbackLines`).
`-monitorfont <font-description>`
  Set the monitor font for the Gtk3 UI's VTE-monitor. (`MonitorFont`).
`-monitorfg <colour-description>`
  Set the monitor foreground colour for the Gtk3 UI's VTE-monitor. (`MonitorFG`).
`-monitorbg <colour-description>`
  Set the monitor background colour for the Gtk3 UI's VTE-monitor. (`MonitorFG`).
`-monitorxpos <X-position>`
  Set window X position for the Gtk3 UI's VTE-monitor. (`MonitorXPos`).
`-monitorxpos <Y-position>`
  Set window Y position for the Gtk3 UI's VTE-monitor. (`MonitorYPos`).
`-monitorwidth <width>`
  Set window width for the Gtk3 UI's VTE-monitor. (`MonitorWidth`).
`-monitorheight <height>`
  Set window height for the Gtk3 UI's VTE-monitor. (`MonitorHeight`).

## 6.18 RAM init pattern settings

The initial content of uninitialized RAM depends on many factors, the inner workings of the RAM chip, the motherboard, etc. Generally, many RAM chips are build in a way that - however - at powerup about half the bits turn out 1, and about the other half turns out 0. As a consequence, and depending on what kind of RAM chips have been used in what kind of way, the typical patterns can be "seen" by the CPU right after powerup.

VICE tries to model (some of) the real patterns accurately. Please be aware of the fact that there is - technically buggy - software out there that will only work with a certain RAM init pattern.

How generating the pattern works is easily described in three simple steps:

1. A base pattern is created using blocks of `RAMInitStartValue`, which is inverted every `RAMInitValueInvert` bytes. This pattern can be offset ("rotated") by `RAMInitValueOffset` bytes. This step creates the typical 00 00 ff ff ff ff 00 00 etc patterns.

2. Every `RAMInitPatternInvert` bytes the base pattern is inverted ("xored") by `RAMInitPatternInvertValue`. This step creates the inverted pattern every $4000 or so bytes that is typical for some boards/ICs. It may also create the 0x99, 0x66 based patterns that show up on other setups.

3. Every `RAMInitRepeatRandom` bytes `RAMInitStartRandom` bytes are randomly inverted ("xored"). Additionally every bit is randomly inverted with a `RAMInitRandomChance` : 10000 chance. This step creates the typical random bytes that have been observed with some boards/ICs.

### 6.18.1 RAM init pattern resources

`RAMInitStartValue`
  Integer specifying the first value of the base pattern (all emulators except vsid). (0..255)
`RAMInitValueInvert`
  Integer specifying the number of bytes until the base pattern is inverted (all emulators except vsid).
`RAMInitValueOffset`
  Integer specifying the number of bytes to offset the base pattern (all emulators except vsid).
`RAMInitPatternInvert`
  Integer specifying the length of the memory block when inverting the base pattern (all emulators except vsid).
`RAMInitPatternInvertValue`
  Integer specifying the value to use for inverting the base pattern with (all emulators except vsid).
`RAMInitStartRandom`
  Integer specifying the number of random bytes in the random pattern (all emulators except vsid).
`RAMInitRepeatRandom`
  Integer specifying the number of bytes after which to repeat the random pattern (all emulators except vsid).
`RAMInitRandomChance`
  Integer specifying the chance of any bit to randomly toggle (0-4096) (all emulators except vsid).

### 6.18.2 RAM init pattern command-line options

`-raminitstartvalue <value>`
  Set the first value of the base pattern (`RAMInitStartValue`) (all emulators except vsid). (0..255)
`-raminitvalueinvert <num of bytes>`
  Set the number of bytes until the base pattern is inverted (`RAMInitValueInvert`) (all emulators except vsid).
`-raminitvalueoffset <num of bytes>`
  Offset the first pattern by <num> of bytes (`RAMInitValueOffset`) (all emulators except vsid).
`-raminitpatterninvert <num of bytes>`
  Set the length of the memory block when inverting the base pattern (`RAMInitPatternInvert`) (all emulators except vsid).
`-raminitpatterninvertvalue <value>`
  Set the value to invert the base pattern with (`RAMInitPatternInvertValue`) (all emulators except vsid).
`-raminitstartrandom <num of bytes>`
  Set the number of random bytes in the random pattern (`RAMInitStartRandom`) (all emulators except vsid).
`-raminitrepeatrandom <num of bytes>`
  Set the number of bytes after which to repeat the random pattern (`RAMInitRepeatRandom`) (all emulators except vsid).
`-raminitrandomchance <value>`
  Set the chance of any bit to randomly toggle (0-4096) (`RAMInitRandomChance`) (all emulators except vsid).

## 6.19 Debug settings

### 6.19.1 Debug resources

`DebugCartEnable`
  Boolean specifying whether the debug "cartridge" used for the test suite is enabled.
`LogLevelANE`
  Integer specifying the log mode (0=none 1=only unstable 2=all) (x64sc, xvic).
`LogLevelLXA`
  Integer specifying the log mode (0=none 1=only unstable 2=all) (x64sc, xvic).

The following are only available when the emulators were compiled in DEBUG mode:

`TraceMode`
  Integer specifying the trace mode (0=normal 1=small 2=history)
`AutoPlaybackFrames`
  Amount of automatic playback frames
`MainCPU_TRACE`
  Trace the main CPU / Do not trace the main CPU
`Drive0CPU_TRACE`
  Trace the drive 0 CPU / Do not trace the drive 0 CPU
`Drive1CPU_TRACE`
  Trace the drive 1 CPU / Do not trace the drive 1 CPU
`Drive2CPU_TRACE`
  Trace the drive 2 CPU / Do not trace the drive 2 CPU
`Drive3CPU_TRACE`
  Trace the drive 3 CPU / Do not trace the drive 3 CPU
`IEC_TRACE`
  Trace IEC bus activity / Do not trace IEC bus activity
`IEEE_TRACE`
  Trace IEEE bus activity / Do not trace IEEE bus activity

### 6.19.2 Debug command-line options

`-core`
`+core`
  Enable/disable generation of core dumps (`DoCoreDump=1`, `DoCoreDump=0`) (all emulators except vsid).
`-debug`
`+debug`
  Disable/enable calling of the exception handler (`DoCoreDump=1`, `DoCoreDump=0`) (all emulators except vsid).
`-debugcart`
`+debugcart`
  Enable/disable the debug "cartridge" used for the test suite.
`-aneloglevel <mode>`
  Set the log mode (0=none 1=only unstable 2=all) (`LogLevelANE`) (x64sc, xvic).
`-lxaloglevel <mode>`
  Set the log mode (0=none 1=only unstable 2=all) (`LogLevelLXA`) (x64sc, xvic).

The following are only available when the emulators were compiled in DEBUG mode:

`-trace_maincpu`
`+trace_maincpu`
  Trace the main CPU / Do not trace the main CPU (`MainCPU_TRACE=1`, `MainCPU_TRACE=0`)
`-trace_drive0`
`+trace_drive0`
  Trace the drive 0 CPU / Do not trace the drive 0 CPU (`Drive0CPU_TRACE=1`, `Drive0CPU_TRACE=0`)
`-trace_drive1`
`+trace_drive1`
  Trace the drive 1 CPU / Do not trace the drive 1 CPU (`Drive1CPU_TRACE=1`, `Drive1CPU_TRACE=0`)
`-trace_drive2`
`+trace_drive2`
  Trace the drive 2 CPU / Do not trace the drive 2 CPU (`Drive2CPU_TRACE=1`, `Drive2CPU_TRACE=0`)
`-trace_drive3`
`+trace_drive3`
  Trace the drive 3 CPU / Do not trace the drive 3 CPU (`Drive3CPU_TRACE=1`, `Drive3CPU_TRACE=0`)
`-trace_iec`
`+trace_iec`
  Trace IEC bus activity / Do not trace IEC bus activity (`IEC_TRACE=1`, `IEC_TRACE=0`)
`-trace_mode <value>`
  Trace mode (0=normal 1=small 2=history)
`-autoplaybackframes <frames>`
  Set the amount of automatic playback frames

## 6.20 Network Play settings

Note network play code is still experimental and unstable in some corners and can be a bit tricky to setup and made work:

- First make sure both client and server can actually use the port you want to use. This might require poking holes into your firewall. On the server side, this often requires configuring port forwarding.
- Choose a port you want to use. Usually the default (6502) is fine.
- Setup the server address, usually you can leave it blank - if that does not work you might have to use the actual IP of your machine. Start the server and leave the settings before you continue.
- On the client setup the remote address of the server (use 127.0.0.1 to connect to another VICE instance running on the same machine) and connect to the server.

The experimental nature of this feature also means that you might require both involved parties to use the exact same version of VICE.

### 6.20.1 Network Play resources

`NetworkServerName`
  String specifying the name of the remote server. The client specifies here to what remote machine it wants to connect. To connect to another instance of VICE running on the same machine use 127.0.0.1.
`NetworkServerBindAddress`
  String specifying the IP of the remote server. The server specifies here at what IP it listens. This can be blank in common setups.
`NetworkServerPort`
  Integer specifying the port used for network play. This must be a number > 1023 (non privileged) and must be the same on both server and client.
`NetworkControl`
  Integer containing a bitfield that specifies which resources are controlled by either the server or the client:

  Bit | Resource | controlled by
  0 | Keyboard | Server
  1 | Joystick port 1 | Server
  2 | Joystick port 2 | Server
  3 | Devices | Server
  4 | Resources | Server
  5 | Keyboard | Client
  6 | Joystick port 1 | Client
  7 | Joystcik port 2 | Client
  8 | Devices | Client
  9 | Resources | Client

### 6.20.2 Network Play command-line options

`-netplayserver <name>`
  Set the name of the remote server (`NetworkServerName`).
`-netplaybind <ip>`
  Set the IP of the remote server (`NetworkServerBindAddress`).
`-netplayport <port>`
  Set the port used for network play (`NetworkServerPort`).
`-netplayctrl <flag>`
  Specify what resources are controlled by the server or the client (see above) (`NetworkControl`).

Go to the first, previous, next, last section, table of contents.